mailarchive of the pengutronix oss-tools mailing list
 help / color / mirror / Atom feed
* [OSS-Tools] [PATCH 0/5] Add meson support and first test suite
@ 2023-05-31 15:31 Ahmad Fatoum
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 1/5] Add meson as build system Ahmad Fatoum
                   ` (5 more replies)
  0 siblings, 6 replies; 9+ messages in thread
From: Ahmad Fatoum @ 2023-05-31 15:31 UTC (permalink / raw)
  To: oss-tools

The barebox,state binding is quite complex and we have a lot of udev
parsing code that can only be exercised by manually running
barebox-state on the target. Make development less error prone, by
adding tests for the block device bindings. EEPROM and MTD can
follow later.

Tests are executed by meson as a runner. Patches to teach autotools
to do the same are welcome, although I think we should follow RAUC's
steps and eventually deprecate autotools once meson is on par.

The obvious wart is that we build with -fvisibility=hidden on autotools,
but with meson the same visibility option results in linker errors.

I have no idea why yet, but that should only make meson-built
libdt-utils a bit slower without functional change.

Ahmad Fatoum (5):
  Add meson as build system
  state: add option to lock device node
  meson: add simple integration test
  libdt: add CONFIG_TEST_LOOPBACK
  test: add barebox-state loop block device tests

 .gitignore                                    |   2 +
 README                                        |  21 +
 check-news.sh                                 |  82 ++
 configure.ac                                  |  11 +
 meson.build                                   | 163 ++++
 meson_options.txt                             |  25 +
 src/barebox-state.c                           |  30 +-
 src/barebox-state/state.c                     |   4 +
 src/barebox-state/state.h                     |  21 +
 src/dt/dt.h                                   |   1 -
 src/libdt.c                                   |  50 +-
 test/01-fixed-partition-no-gpt.dts            |  34 +
 ...2-fixed-partition-before-gpt-partition.dts |  34 +
 test/03-fixed-partition-is-gpt-partition.dts  |  34 +
 test/04-gpt-partition-by-partuuid.dts         |  31 +
 test/05-gpt-partition-by-typeuuid.dts         |  23 +
 test/06-fixed-partition-by-diskuuid.dts       |  33 +
 test/07-raw-disk-fail.dts                     |  18 +
 test/08-gpt-disk-no-typeuuid-fail.dts         |  18 +
 ...-partition-overlaps-two-gpt-partitions.dts |  34 +
 ...-overlaps-two-gpt-partitions-partially.dts |  34 +
 ...-fixed-partition-part-of-gpt-partition.dts |  34 +
 test/barebox-state.dtsi                       |  53 ++
 test/barebox-state.t                          | 229 +++++
 test/crc32.c                                  |  18 +
 test/gpt-no-typeuuid.config                   |  33 +
 test/gpt.config                               |  35 +
 test/meson.build                              |  36 +
 test/raw.config                               |  24 +
 test/sharness.sh                              | 857 ++++++++++++++++++
 version-gen                                   |   3 +
 version.h.in                                  |   3 +
 32 files changed, 2012 insertions(+), 16 deletions(-)
 create mode 100755 check-news.sh
 create mode 100644 meson.build
 create mode 100644 meson_options.txt
 create mode 100644 test/01-fixed-partition-no-gpt.dts
 create mode 100644 test/02-fixed-partition-before-gpt-partition.dts
 create mode 100644 test/03-fixed-partition-is-gpt-partition.dts
 create mode 100644 test/04-gpt-partition-by-partuuid.dts
 create mode 100644 test/05-gpt-partition-by-typeuuid.dts
 create mode 100644 test/06-fixed-partition-by-diskuuid.dts
 create mode 100644 test/07-raw-disk-fail.dts
 create mode 100644 test/08-gpt-disk-no-typeuuid-fail.dts
 create mode 100644 test/31-fixed-partition-overlaps-two-gpt-partitions.dts
 create mode 100644 test/32-fixed-partition-overlaps-two-gpt-partitions-partially.dts
 create mode 100644 test/33-fixed-partition-part-of-gpt-partition.dts
 create mode 100644 test/barebox-state.dtsi
 create mode 100755 test/barebox-state.t
 create mode 100644 test/crc32.c
 create mode 100644 test/gpt-no-typeuuid.config
 create mode 100644 test/gpt.config
 create mode 100644 test/meson.build
 create mode 100644 test/raw.config
 create mode 100755 test/sharness.sh
 create mode 100755 version-gen
 create mode 100644 version.h.in

-- 
2.39.2




^ permalink raw reply	[flat|nested] 9+ messages in thread

* [OSS-Tools] [PATCH 1/5] Add meson as build system
  2023-05-31 15:31 [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Ahmad Fatoum
@ 2023-05-31 15:31 ` Ahmad Fatoum
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 2/5] state: add option to lock device node Ahmad Fatoum
                   ` (4 subsequent siblings)
  5 siblings, 0 replies; 9+ messages in thread
From: Ahmad Fatoum @ 2023-05-31 15:31 UTC (permalink / raw)
  To: oss-tools

This adds experimental support for building dt-utils with meson. The
hope is that the alternative meson.build will be easier to maintain.

Signed-off-by: Ahmad Fatoum <a.fatoum@pengutronix.de>
---
 .gitignore        |   1 +
 README            |  20 ++++++
 check-news.sh     |  82 ++++++++++++++++++++++++
 meson.build       | 159 ++++++++++++++++++++++++++++++++++++++++++++++
 meson_options.txt |  25 ++++++++
 version-gen       |   3 +
 version.h.in      |   3 +
 7 files changed, 293 insertions(+)
 create mode 100755 check-news.sh
 create mode 100644 meson.build
 create mode 100644 meson_options.txt
 create mode 100755 version-gen
 create mode 100644 version.h.in

diff --git a/.gitignore b/.gitignore
index 5ee5535f544f..34df220d8723 100644
--- a/.gitignore
+++ b/.gitignore
@@ -15,6 +15,7 @@ Makefile.in
 /stamp-h1
 /tags
 /TAGS
+/build/
 
 /fdtdump
 /src/libdt-utils.pc
diff --git a/README b/README
index 46b4ea9c1508..0b4e96d6002e 100644
--- a/README
+++ b/README
@@ -13,6 +13,26 @@ For questions, feedback, patches, please send a mail to
 Note: you must be subscribed to post to this mailing list. You can do so by
 sending an empty mail to <oss-tools-subscribe@pengutronix.de>.
 
+Building from Sources
+---------------------
+
+Check out the latest git state:
+
+    git clone https://github.com/barebox/dt-utils
+    cd dt-utils
+
+And then build using autotools:
+
+    ./autogen.sh
+    ./configure
+    make
+
+There's also experimental support for building with meson.
+The intention is to deprecate autotools eventually in its favor. To build:
+
+    meson setup build
+    meson compile -C build
+
 Contributing
 ------------
 
diff --git a/check-news.sh b/check-news.sh
new file mode 100755
index 000000000000..e7e8fa6bb95d
--- /dev/null
+++ b/check-news.sh
@@ -0,0 +1,82 @@
+#!/bin/sh
+
+# Copyright (C) 2019 Red Hat, Inc.
+# Author: Bastien Nocera <hadess@hadess.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA.
+
+
+# Add to your top-level meson.build to check for an updated NEWS file
+# when doing a "dist" release, similarly to automake's check-news:
+# https://www.gnu.org/software/automake/manual/html_node/List-of-Automake-options.html
+#
+# Checks NEWS for the version number:
+# meson.add_dist_script(
+#   find_program('check-news.sh').path(),
+#   '@0@'.format(meson.project_version())
+# )
+#
+# Checks NEWS and data/foo.appdata.xml for the version number:
+# meson.add_dist_script(
+#   find_program('check-news.sh').path(),
+#   '@0@'.format(meson.project_version()),
+#   'NEWS',
+#   'data/foo.appdata.xml'
+# )
+
+usage()
+{
+	echo "$0 VERSION [FILES...]"
+	exit 1
+}
+
+check_version()
+{
+	VERSION=$1
+	# Look in the first 15 lines for NEWS files, but look
+	# everywhere for other types of files
+	if [ "$2" = "NEWS" ]; then
+		DATA=`sed 15q $SRC_ROOT/"$2"`
+	else
+		DATA=`cat $SRC_ROOT/"$2"`
+	fi
+	case "$DATA" in
+	*"$VERSION"*)
+		:
+		;;
+	*)
+		echo "$2 not updated; not releasing" 1>&2;
+		exit 1
+		;;
+	esac
+}
+
+SRC_ROOT=${MESON_DIST_ROOT:-"./"}
+
+if [ $# -lt 1 ] ; then usage ; fi
+
+VERSION=$1
+shift
+
+if [ $# -eq 0 ] ; then
+	check_version $VERSION 'NEWS'
+	exit 0
+fi
+
+for i in $@ ; do
+	check_version $VERSION "$i"
+done
+
+exit 0
diff --git a/meson.build b/meson.build
new file mode 100644
index 000000000000..22b522ea4d0e
--- /dev/null
+++ b/meson.build
@@ -0,0 +1,159 @@
+# Copyright 2013-2023 The DT-Utils Authors <oss-tools@pengutronix.de>
+# Homepage: https://git.pengutronix.de/cgit/tools/dt-utils
+
+project(
+  'dt-utils',
+  'c',
+  version : '2021.03.0',
+  meson_version : '>=0.51',
+  default_options: [
+    'c_std=gnu11',
+    'warning_level=2',
+  ],
+  license : 'GPL-2.0-only',
+)
+
+cc = meson.get_compiler('c')
+
+conf = configuration_data()
+# Statically define to be enabled to harmonize barebox' & dt-utils' code base.
+conf.set10('CONFIG_MTD', true)
+conf.set10('CONFIG_STATE', true)
+conf.set10('CONFIG_STATE_BACKWARD_COMPATIBLE', get_option('state-backward-compatibility'))
+
+meson.add_dist_script(
+  find_program('check-news.sh').path(),
+  '@0@'.format(meson.project_version())
+)
+
+prefixdir = get_option('prefix')
+if not prefixdir.startswith('/')
+        error('Prefix is not absolute: "@0@"'.format(prefixdir))
+endif
+sysconfdir = join_paths(prefixdir, get_option('sysconfdir'))
+conf.set('SYSCONFDIR', sysconfdir)
+libexecdir = join_paths(prefixdir, get_option('libexecdir'))
+conf.set('LIBEXECDIR', libexecdir)
+
+udevdep = dependency('libudev')
+
+c_flags = '''
+  -fno-strict-aliasing
+  -ffunction-sections
+  -fdata-sections
+'''.split()
+
+c_warn_flags = '''
+  -Wmissing-declarations
+  -Wmissing-prototypes
+  -Wnested-externs
+  -Wno-sign-compare
+  -Wno-unused-parameter
+  -Wchar-subscripts
+  -Wstrict-prototypes
+  -Wshadow
+  -Wformat-security
+  -Wtype-limits
+  -Wno-pointer-sign
+  -Wno-shadow
+'''.split()
+c_flags += cc.get_supported_arguments(c_warn_flags)
+add_project_arguments(c_flags, language : 'c')
+# enable GNU extensions (required!)
+add_project_arguments('-D_GNU_SOURCE', language : 'c')
+
+ld_flags = '''
+  -Wl,--gc-sections
+  -Wl,--as-needed
+'''.split()
+
+incdir = include_directories(['src/dt', 'src'])
+
+sources_libdt = files('''
+  src/crc32.c
+  src/libdt.c
+  src/fdt.c
+'''.split())
+
+if get_option('barebox-state')
+  sources_barebox_state = files('''
+    src/crypto/digest.c
+    src/crypto/hmac.c
+    src/crypto/sha1.c
+    src/crypto/sha2.c
+    src/keystore-blob.c
+    src/base64.c
+    src/barebox-state/backend_bucket_circular.c
+    src/barebox-state/backend_bucket_direct.c
+    src/barebox-state/backend_format_dtb.c
+    src/barebox-state/backend_format_raw.c
+    src/barebox-state/backend_storage.c
+    src/barebox-state/state.c
+    src/barebox-state/state_variables.c
+    src/barebox-state.c
+  '''.split())
+endif
+
+sources_dtblint = files('''
+  src/dtblint.c
+  src/dtblint-imx-pinmux.c
+  src/dtblint.h
+'''.split())
+
+sources_fdtdump = files('''
+src/fdtdump.c
+'''.split())
+
+config_h = configure_file(
+  output : 'config.h',
+  configuration : conf
+)
+add_project_arguments('-include', meson.current_build_dir() / 'config.h', language : 'c')
+
+version_h = vcs_tag(
+  input : 'version.h.in',
+  output : 'version.h',
+)
+versiondep = declare_dependency(sources: version_h)
+
+meson.add_dist_script('version-gen', meson.project_version())
+
+mapfile = 'src/libdt-utils.sym'
+libdt_ld_flags = '-Wl,--version-script,@0@/@1@'.format(meson.current_source_dir(), mapfile)
+
+libdt = shared_library('dt-utils',
+  sources_libdt,
+  include_directories : incdir,
+  link_args : ld_flags + ['-Wl,--no-undefined', libdt_ld_flags],
+  link_depends : mapfile,
+  c_args : ['-include', meson.current_build_dir() / 'version.h'],
+  dependencies : [udevdep, versiondep],
+  gnu_symbol_visibility : 'default',
+  install : true)
+
+executable('barebox-state',
+  sources_barebox_state,
+  include_directories : incdir,
+  link_args : ld_flags,
+  c_args : ['-include', meson.current_build_dir() / 'version.h'],
+  dependencies : [versiondep],
+  link_with : libdt,
+  install : true)
+
+executable('fdtdump',
+  sources_fdtdump,
+  include_directories : incdir,
+  link_args : ld_flags,
+  c_args : ['-include', meson.current_build_dir() / 'version.h'],
+  dependencies : [versiondep],
+  link_with : libdt,
+  install : true)
+
+executable('dtblint',
+  sources_dtblint,
+  include_directories : incdir,
+  link_args : ld_flags,
+  c_args : ['-include', meson.current_build_dir() / 'version.h'],
+  dependencies : [versiondep],
+  link_with : libdt,
+  install : true)
diff --git a/meson_options.txt b/meson_options.txt
new file mode 100644
index 000000000000..f80643aa6c73
--- /dev/null
+++ b/meson_options.txt
@@ -0,0 +1,25 @@
+# feature options
+option(
+  'state-backward-compatibility',
+  type : 'boolean',
+  value : 'false',
+  description : 'barebox-state: when using the "direct" storage backend, keep the on-disk format readable by barebox <= v2016.08.0')
+
+option(
+  'lock-device',
+  type : 'boolean',
+  value : 'false',
+  description : 'lock device node instead of creating lockfile in /run')
+
+# build options
+option(
+  'barebox-state',
+  type : 'boolean',
+  value : 'true',
+  description : 'Build barebox-state utility')
+
+option(
+  'tests',
+  type : 'boolean',
+  value : 'true',
+  description : 'Enable/Disable test suite')
diff --git a/version-gen b/version-gen
new file mode 100755
index 000000000000..bf77f50bc1e7
--- /dev/null
+++ b/version-gen
@@ -0,0 +1,3 @@
+#!/bin/sh
+
+echo "$1" > "$MESON_DIST_ROOT/.tarball-version"
diff --git a/version.h.in b/version.h.in
new file mode 100644
index 000000000000..a0c0ce367ab7
--- /dev/null
+++ b/version.h.in
@@ -0,0 +1,3 @@
+#define PACKAGE_STRING "dt-utils @VCS_TAG@"
+
+#define PACKAGE_VERSION "@VCS_TAG@"
-- 
2.39.2




^ permalink raw reply	[flat|nested] 9+ messages in thread

* [OSS-Tools] [PATCH 2/5] state: add option to lock device node
  2023-05-31 15:31 [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Ahmad Fatoum
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 1/5] Add meson as build system Ahmad Fatoum
@ 2023-05-31 15:31 ` Ahmad Fatoum
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 3/5] meson: add simple integration test Ahmad Fatoum
                   ` (3 subsequent siblings)
  5 siblings, 0 replies; 9+ messages in thread
From: Ahmad Fatoum @ 2023-05-31 15:31 UTC (permalink / raw)
  To: oss-tools

Even if /run exists, it may not be world-writable. This is the case on
NixOS. Add an alternative option to lock the device node instead.

This should eventually be made the default when it has enjoyed more
testing.

Signed-off-by: Ahmad Fatoum <a.fatoum@pengutronix.de>
---
 configure.ac              |  9 +++++++++
 meson.build               |  1 +
 src/barebox-state.c       | 30 ++++++++++++++++++------------
 src/barebox-state/state.c |  4 ++++
 src/barebox-state/state.h | 21 +++++++++++++++++++++
 5 files changed, 53 insertions(+), 12 deletions(-)

diff --git a/configure.ac b/configure.ac
index be8967eb0809..117a1e169ba9 100644
--- a/configure.ac
+++ b/configure.ac
@@ -27,6 +27,15 @@ AS_IF([test "x${enable_state_backward_compatibility}" = "xyes"], [
         AC_DEFINE(CONFIG_STATE_BACKWARD_COMPATIBLE, [0])
 ])
 
+AC_ARG_ENABLE([lock-device],
+        AS_HELP_STRING([--enable-lock-device], [barebox-state: lock device node instead of global lock in /run @<:@default=disabled@:>@]),
+        [], [enable_lock_device=no])
+AS_IF([test "x${enable_lock_device}" = "xyes"], [
+        AC_DEFINE(CONFIG_LOCK_DEVICE_NODE, [1], [lock device node backing state.])
+], [
+        AC_DEFINE(CONFIG_LOCK_DEVICE_NODE, [0], [use global lock in /run.])
+])
+
 AC_DEFINE(CONFIG_MTD, [1], [Statically define to be enabled to harmonize barebox' & dt-utils' code base.])
 
 AC_DEFINE(CONFIG_STATE, [1], [Statically define to be enabled to harmonize barebox' & dt-utils' code base.])
diff --git a/meson.build b/meson.build
index 22b522ea4d0e..2fc13f55ed62 100644
--- a/meson.build
+++ b/meson.build
@@ -20,6 +20,7 @@ conf = configuration_data()
 conf.set10('CONFIG_MTD', true)
 conf.set10('CONFIG_STATE', true)
 conf.set10('CONFIG_STATE_BACKWARD_COMPATIBLE', get_option('state-backward-compatibility'))
+conf.set10('CONFIG_LOCK_DEVICE_NODE', get_option('lock-device'))
 
 meson.add_dist_script(
   find_program('check-news.sh').path(),
diff --git a/src/barebox-state.c b/src/barebox-state.c
index c5acd1f7780a..7cf2fbf070a9 100644
--- a/src/barebox-state.c
+++ b/src/barebox-state.c
@@ -499,6 +499,8 @@ int main(int argc, char *argv[])
 			printf(PACKAGE_STRING "\n");
 			printf("Configured with build-time option '--%s-state-backward-compatibility'.\n",
 			       (CONFIG_STATE_BACKWARD_COMPATIBLE) ? "enable" : "disable");
+			printf("                                  '--%s-lock-device-node'.\n",
+			       (CONFIG_LOCK_DEVICE_NODE) ? "enable" : "disable");
 			exit(0);
 		case 'g':
 			sg = xzalloc(sizeof(*sg));
@@ -568,17 +570,19 @@ int main(int argc, char *argv[])
 		++nr_states;
 	}
 
-	lock_fd = open(BAREBOX_STATE_LOCKFILE, O_CREAT | O_RDWR, 0600);
-	if (lock_fd < 0) {
-		pr_err("Failed to open lock-file " BAREBOX_STATE_LOCKFILE "\n");
-		exit(1);
-	}
+	if (!IS_ENABLED(CONFIG_LOCK_DEVICE_NODE)) {
+		lock_fd = open(BAREBOX_STATE_LOCKFILE, O_CREAT | O_RDWR, 0600);
+		if (lock_fd < 0) {
+			pr_err("Failed to open lock-file " BAREBOX_STATE_LOCKFILE "\n");
+			exit(1);
+		}
 
-	ret = flock(lock_fd, LOCK_EX);
-	if (ret < 0) {
-		pr_err("Failed to lock " BAREBOX_STATE_LOCKFILE ": %m\n");
-		close(lock_fd);
-		exit(1);
+		ret = flock(lock_fd, LOCK_EX);
+		if (ret < 0) {
+			pr_err("Failed to lock " BAREBOX_STATE_LOCKFILE ": %m\n");
+			close(lock_fd);
+			exit(1);
+		}
 	}
 
 	list_for_each_entry(state, &state_list.list, list) {
@@ -700,8 +704,10 @@ int main(int argc, char *argv[])
 
 	ret = 0;
 out_unlock:
-	flock(lock_fd, LOCK_UN);
-	close(lock_fd);
+	if (!IS_ENABLED(CONFIG_LOCK_DEVICE_NODE)) {
+		flock(lock_fd, LOCK_UN);
+		close(lock_fd);
+	}
 
 	return ret;
 }
diff --git a/src/barebox-state/state.c b/src/barebox-state/state.c
index 42ce88d3f161..371ae3959d6c 100644
--- a/src/barebox-state/state.c
+++ b/src/barebox-state/state.c
@@ -664,6 +664,10 @@ struct state *state_new_from_node(struct device_node *node, bool readonly)
 	pr_debug("%s: backend resolved to %s %lld %zu\n", node->full_name,
 		 state->backend_path, (long long)offset, size);
 
+	/* will be released on program exit */
+	if (IS_ENABLED(CONFIG_LOCK_DEVICE_NODE))
+		(void)open_exclusive(state->backend_path, readonly ? O_RDONLY : O_RDWR);
+
 	state->backend_reproducible_name = of_get_reproducible_name(partition_node);
 
 	ret = of_property_read_string(node, "backend-type", &backend_type);
diff --git a/src/barebox-state/state.h b/src/barebox-state/state.h
index 4abfa84285c3..bbbc1892f846 100644
--- a/src/barebox-state/state.h
+++ b/src/barebox-state/state.h
@@ -3,6 +3,7 @@
 #include <linux/types.h>
 #include <linux/list.h>
 #include <driver.h>
+#include <sys/file.h>
 
 struct state;
 struct mtd_info_user;
@@ -269,3 +270,23 @@ static inline int state_string_copy_to_raw(struct state_string *string,
 
 	return 0;
 }
+
+static inline int open_exclusive(const char *path, int flags)
+{
+	int fd;
+
+	fd = open(path, flags);
+	if (fd < 0)
+		return fd;
+
+	if (IS_ENABLED(CONFIG_LOCK_DEVICE_NODE)) {
+		int ret = flock(fd, LOCK_EX);
+		if (ret < 0) {
+			pr_err("Failed to lock %s: %d\n", path, -errno);
+			close(fd);
+			return -EWOULDBLOCK;
+		}
+	}
+
+	return fd;
+}
-- 
2.39.2




^ permalink raw reply	[flat|nested] 9+ messages in thread

* [OSS-Tools] [PATCH 3/5] meson: add simple integration test
  2023-05-31 15:31 [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Ahmad Fatoum
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 1/5] Add meson as build system Ahmad Fatoum
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 2/5] state: add option to lock device node Ahmad Fatoum
@ 2023-05-31 15:31 ` Ahmad Fatoum
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 4/5] libdt: add CONFIG_TEST_LOOPBACK Ahmad Fatoum
                   ` (2 subsequent siblings)
  5 siblings, 0 replies; 9+ messages in thread
From: Ahmad Fatoum @ 2023-05-31 15:31 UTC (permalink / raw)
  To: oss-tools

It's straight forward to use meson as test runner, so let's compile a
very simple test application that links against libdt-utils and verifies
crc32 behaves as one would expect.

Signed-off-by: Ahmad Fatoum <a.fatoum@pengutronix.de>
---
 README           |  1 +
 meson.build      |  2 ++
 test/crc32.c     | 18 ++++++++++++++++++
 test/meson.build | 26 ++++++++++++++++++++++++++
 4 files changed, 47 insertions(+)
 create mode 100644 test/crc32.c
 create mode 100644 test/meson.build

diff --git a/README b/README
index 0b4e96d6002e..528751d2cb65 100644
--- a/README
+++ b/README
@@ -32,6 +32,7 @@ The intention is to deprecate autotools eventually in its favor. To build:
 
     meson setup build
     meson compile -C build
+    meson test -C build  # optional
 
 Contributing
 ------------
diff --git a/meson.build b/meson.build
index 2fc13f55ed62..1bc32274af07 100644
--- a/meson.build
+++ b/meson.build
@@ -158,3 +158,5 @@ executable('dtblint',
   dependencies : [versiondep],
   link_with : libdt,
   install : true)
+
+subdir('test')
diff --git a/test/crc32.c b/test/crc32.c
new file mode 100644
index 000000000000..9a99254c8f22
--- /dev/null
+++ b/test/crc32.c
@@ -0,0 +1,18 @@
+#include <stdint.h>
+#include <assert.h>
+
+#include <dt/common.h>
+
+int main(void)
+{
+	const char *str = "Hello, World!";
+	uint32_t checksum;
+
+	checksum = crc32(0, str, strlen(str));
+	assert(checksum == 0xec4ac3d0);
+
+	checksum = crc32_no_comp(0, str, strlen(str));
+	assert(checksum == 0xe33e8552);
+
+	return 0;
+}
diff --git a/test/meson.build b/test/meson.build
new file mode 100644
index 000000000000..5e073547d79b
--- /dev/null
+++ b/test/meson.build
@@ -0,0 +1,26 @@
+if not get_option('tests')
+  subdir_done()
+endif
+
+tests = [
+  'crc32',
+]
+
+extra_test_sources = files([
+])
+
+foreach test_name : tests
+  exe = executable(
+    test_name + '-test',
+    test_name + '.c',
+    extra_test_sources,
+    link_with : [libdt],
+    include_directories : incdir)
+
+  test(
+    test_name,
+    exe,
+    is_parallel : false,
+    timeout : 240,
+    workdir : meson.source_root())
+endforeach
-- 
2.39.2




^ permalink raw reply	[flat|nested] 9+ messages in thread

* [OSS-Tools] [PATCH 4/5] libdt: add CONFIG_TEST_LOOPBACK
  2023-05-31 15:31 [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Ahmad Fatoum
                   ` (2 preceding siblings ...)
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 3/5] meson: add simple integration test Ahmad Fatoum
@ 2023-05-31 15:31 ` Ahmad Fatoum
  2023-06-12 11:56   ` Ahmad Fatoum
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 5/5] test: add barebox-state loop block device tests Ahmad Fatoum
  2023-06-05 10:17 ` [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Roland Hieber
  5 siblings, 1 reply; 9+ messages in thread
From: Ahmad Fatoum @ 2023-05-31 15:31 UTC (permalink / raw)
  To: oss-tools

We have quite a bit of tricky udev and device tree parsing code that is
only tested manually. Best case we would have tests for this in QEMU,
but until we do, let's test it with loop devices:

The downside is that we can only test block devices and that we need
a tiny bit of code that's not used normally, but on the upside, we
have tests. :-)

Signed-off-by: Ahmad Fatoum <a.fatoum@pengutronix.de>
---
 configure.ac |  2 ++
 meson.build  |  1 +
 src/dt/dt.h  |  1 -
 src/libdt.c  | 50 +++++++++++++++++++++++++++++++++++++++++++++++---
 4 files changed, 50 insertions(+), 4 deletions(-)

diff --git a/configure.ac b/configure.ac
index 117a1e169ba9..5b5c74c2b582 100644
--- a/configure.ac
+++ b/configure.ac
@@ -40,6 +40,8 @@ AC_DEFINE(CONFIG_MTD, [1], [Statically define to be enabled to harmonize barebox
 
 AC_DEFINE(CONFIG_STATE, [1], [Statically define to be enabled to harmonize barebox' & dt-utils' code base.])
 
+AC_DEFINE(CONFIG_TEST_LOOPBACK, [0], [Only enabled in meson for testing.])
+
 AC_CHECK_FUNCS([__secure_getenv secure_getenv])
 
 my_CFLAGS="-Wall \
diff --git a/meson.build b/meson.build
index 1bc32274af07..be92446f137a 100644
--- a/meson.build
+++ b/meson.build
@@ -21,6 +21,7 @@ conf.set10('CONFIG_MTD', true)
 conf.set10('CONFIG_STATE', true)
 conf.set10('CONFIG_STATE_BACKWARD_COMPATIBLE', get_option('state-backward-compatibility'))
 conf.set10('CONFIG_LOCK_DEVICE_NODE', get_option('lock-device'))
+conf.set10('CONFIG_TEST_LOOPBACK', get_option('tests'))
 
 meson.add_dist_script(
   find_program('check-news.sh').path(),
diff --git a/src/dt/dt.h b/src/dt/dt.h
index a4213d49606a..153b56e09a21 100644
--- a/src/dt/dt.h
+++ b/src/dt/dt.h
@@ -220,7 +220,6 @@ extern int of_set_root_node(struct device_node *node);
 extern int of_platform_populate(struct device_node *root,
 				const struct of_device_id *matches,
 				struct device_d *parent);
-extern struct device_d *of_find_device_by_node(struct device_node *np);
 
 int of_device_is_stdout_path(struct device_d *dev);
 const char *of_get_model(void);
diff --git a/src/libdt.c b/src/libdt.c
index af28de6f17c6..7c24c9197c7f 100644
--- a/src/libdt.c
+++ b/src/libdt.c
@@ -2091,6 +2091,22 @@ struct udev_of_path {
 
 static LIST_HEAD(udev_of_devices);
 
+static const char *udev_device_get_of_path(struct udev_device *dev)
+{
+	const char *of_path;
+
+	of_path = udev_device_get_property_value(dev, "OF_FULLNAME");
+	if (of_path)
+		return of_path;
+
+	if (IS_ENABLED(CONFIG_TEST_LOOPBACK) &&
+	    !strcmp(udev_device_get_subsystem(dev), "block") &&
+	    !strncmp(udev_device_get_sysname(dev), "loop", 4))
+		return udev_device_get_sysname(dev);
+
+	return NULL;
+}
+
 static void of_scan_udev_devices(void)
 {
 	struct udev *udev;
@@ -2111,6 +2127,8 @@ static void of_scan_udev_devices(void)
 	udev_enumerate_add_match_subsystem(enumerate, "spi");
 	udev_enumerate_add_match_subsystem(enumerate, "mtd");
 	udev_enumerate_add_match_subsystem(enumerate, "amba");
+	if (IS_ENABLED(CONFIG_TEST_LOOPBACK))
+		udev_enumerate_add_match_subsystem(enumerate, "block");
 	udev_enumerate_scan_devices(enumerate);
 	devices = udev_enumerate_get_list_entry(enumerate);
 
@@ -2124,7 +2142,7 @@ static void of_scan_udev_devices(void)
 		path = udev_list_entry_get_name(dev_list_entry);
 		dev = udev_device_new_from_syspath(udev, path);
 
-		of_path = udev_device_get_property_value(dev, "OF_FULLNAME");
+		of_path = udev_device_get_of_path(dev);
 		if (!of_path)
 			continue;
 
@@ -2148,11 +2166,37 @@ struct udev_device *of_find_device_by_node_path(const char *of_full_path)
 			ret = udev_of_path->udev;
 			break;
 		}
+		if (!strcmp(udev_of_path->of_path, of_full_path)) {
+			ret = udev_of_path->udev;
+			break;
+		}
 	}
 
 	return ret;
 }
 
+static struct udev_device *of_find_device_by_node(struct device_node *np)
+{
+	struct udev_of_path *udev_of_path;
+	struct udev_device *dev;
+	const char *filename;
+
+	dev = of_find_device_by_node_path(np->full_name);
+	if (dev)
+		return dev;
+
+	if (IS_ENABLED(CONFIG_TEST_LOOPBACK) &&
+	    !of_property_read_string(np, "barebox,filename", &filename) &&
+	    !strncmp(filename, "/dev/", 5)) {
+		list_for_each_entry(udev_of_path, &udev_of_devices, list) {
+			if (!strcmp(udev_of_path->of_path, filename + 5))
+				return udev_of_path->udev;
+		}
+	}
+
+	return NULL;
+}
+
 static struct udev_device *device_find_mtd_partition(struct udev_device *dev,
 		const char *name)
 {
@@ -2546,7 +2590,7 @@ static int __of_cdev_find(struct device_node *partition_node, struct cdev *cdev)
 	 * 42e9401bd146 ("mtd: Add partition device node to mtd partition
 	 * devices").
 	 */
-	dev = of_find_device_by_node_path(partition_node->full_name);
+	dev = of_find_device_by_node(partition_node);
 	if (dev) {
 		if (udev_device_is_eeprom(dev))
 			return udev_parse_eeprom(dev, &cdev->devpath);
@@ -2619,7 +2663,7 @@ static int __of_cdev_find(struct device_node *partition_node, struct cdev *cdev)
 		}
 	}
 	else {
-		dev = of_find_device_by_node_path(node->full_name);
+		dev = of_find_device_by_node(node);
 		if (!dev) {
 			fprintf(stderr, "%s: cannot find device from node %s\n", __func__,
 					node->full_name);
-- 
2.39.2




^ permalink raw reply	[flat|nested] 9+ messages in thread

* [OSS-Tools] [PATCH 5/5] test: add barebox-state loop block device tests
  2023-05-31 15:31 [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Ahmad Fatoum
                   ` (3 preceding siblings ...)
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 4/5] libdt: add CONFIG_TEST_LOOPBACK Ahmad Fatoum
@ 2023-05-31 15:31 ` Ahmad Fatoum
  2023-06-05 10:17 ` [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Roland Hieber
  5 siblings, 0 replies; 9+ messages in thread
From: Ahmad Fatoum @ 2023-05-31 15:31 UTC (permalink / raw)
  To: oss-tools

There's certainly more unit tests to be had, but the biggest ROI is
probably feeding barebox-state device trees and verifying that they
work. This same use case exists with RAUC too, where sharness (shell
test harness) is used to test the rauc executable. Let's import it from
there and follow the structure of the RAUC tests to do some basic
testing of barebox-state's block device handling.

The basic testing flow is:

  - mount loop devices
  - compile and supply device tree snippet describing state on
    loop device to the barebox-state utility
  - barebox-state is called with verbose output to report which
    device it uses
  - tests check correct device was used and basic state reading
    and writing works.

Signed-off-by: Ahmad Fatoum <a.fatoum@pengutronix.de>
---
 .gitignore                                    |   1 +
 test/01-fixed-partition-no-gpt.dts            |  34 +
 ...2-fixed-partition-before-gpt-partition.dts |  34 +
 test/03-fixed-partition-is-gpt-partition.dts  |  34 +
 test/04-gpt-partition-by-partuuid.dts         |  31 +
 test/05-gpt-partition-by-typeuuid.dts         |  23 +
 test/06-fixed-partition-by-diskuuid.dts       |  33 +
 test/07-raw-disk-fail.dts                     |  18 +
 test/08-gpt-disk-no-typeuuid-fail.dts         |  18 +
 ...-partition-overlaps-two-gpt-partitions.dts |  34 +
 ...-overlaps-two-gpt-partitions-partially.dts |  34 +
 ...-fixed-partition-part-of-gpt-partition.dts |  34 +
 test/barebox-state.dtsi                       |  53 ++
 test/barebox-state.t                          | 229 +++++
 test/gpt-no-typeuuid.config                   |  33 +
 test/gpt.config                               |  35 +
 test/meson.build                              |  10 +
 test/raw.config                               |  24 +
 test/sharness.sh                              | 857 ++++++++++++++++++
 19 files changed, 1569 insertions(+)
 create mode 100644 test/01-fixed-partition-no-gpt.dts
 create mode 100644 test/02-fixed-partition-before-gpt-partition.dts
 create mode 100644 test/03-fixed-partition-is-gpt-partition.dts
 create mode 100644 test/04-gpt-partition-by-partuuid.dts
 create mode 100644 test/05-gpt-partition-by-typeuuid.dts
 create mode 100644 test/06-fixed-partition-by-diskuuid.dts
 create mode 100644 test/07-raw-disk-fail.dts
 create mode 100644 test/08-gpt-disk-no-typeuuid-fail.dts
 create mode 100644 test/31-fixed-partition-overlaps-two-gpt-partitions.dts
 create mode 100644 test/32-fixed-partition-overlaps-two-gpt-partitions-partially.dts
 create mode 100644 test/33-fixed-partition-part-of-gpt-partition.dts
 create mode 100644 test/barebox-state.dtsi
 create mode 100755 test/barebox-state.t
 create mode 100644 test/gpt-no-typeuuid.config
 create mode 100644 test/gpt.config
 create mode 100644 test/raw.config
 create mode 100755 test/sharness.sh

diff --git a/.gitignore b/.gitignore
index 34df220d8723..22060feceab3 100644
--- a/.gitignore
+++ b/.gitignore
@@ -16,6 +16,7 @@ Makefile.in
 /tags
 /TAGS
 /build/
+/test/test-results
 
 /fdtdump
 /src/libdt-utils.pc
diff --git a/test/01-fixed-partition-no-gpt.dts b/test/01-fixed-partition-no-gpt.dts
new file mode 100644
index 000000000000..3ed26e3da468
--- /dev/null
+++ b/test/01-fixed-partition-no-gpt.dts
@@ -0,0 +1,34 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	expected-dev = __RAW_LOOPDEV__;
+	expected-partno = <0>; /* unpartitioned space */
+	expected-offset = <0x8000>;
+	expected-size = <0x8000>;
+
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __RAW_LOOPDEV__;
+		barebox,blockdev;
+
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			part_state: state@8000 {
+				reg = <0x8000 0x8000>;
+				label = "state";
+			};
+		};
+	};
+};
+
+&state {
+	backend = <&part_state>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/02-fixed-partition-before-gpt-partition.dts b/test/02-fixed-partition-before-gpt-partition.dts
new file mode 100644
index 000000000000..b64f910a0cad
--- /dev/null
+++ b/test/02-fixed-partition-before-gpt-partition.dts
@@ -0,0 +1,34 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	expected-dev = __GPT_LOOPDEV__;
+	expected-partno = <0>; /* unpartitioned space */
+	expected-offset = <0x8000>;
+	expected-size = <0x8000>;
+
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __GPT_LOOPDEV__;
+		barebox,blockdev;
+
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			part_state: state@8000 {
+				reg = <0x8000 0x8000>;
+				label = "state";
+			};
+		};
+	};
+};
+
+&state {
+	backend = <&part_state>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/03-fixed-partition-is-gpt-partition.dts b/test/03-fixed-partition-is-gpt-partition.dts
new file mode 100644
index 000000000000..a93c3f194314
--- /dev/null
+++ b/test/03-fixed-partition-is-gpt-partition.dts
@@ -0,0 +1,34 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	expected-dev = __GPT_LOOPDEV__;
+	expected-partno = <2>;
+	expected-offset = <0x00000>;
+	expected-size = <0x8000>;
+
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __GPT_LOOPDEV__;
+		barebox,blockdev;
+
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			part_state: state@20000 {
+				reg = <0x20000 0x8000>;
+				label = "state";
+			};
+		};
+	};
+};
+
+&state {
+	backend = <&part_state>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/04-gpt-partition-by-partuuid.dts b/test/04-gpt-partition-by-partuuid.dts
new file mode 100644
index 000000000000..8c536f1c0c2e
--- /dev/null
+++ b/test/04-gpt-partition-by-partuuid.dts
@@ -0,0 +1,31 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	expected-dev = __GPT_LOOPDEV__;
+	expected-partno = <2>;
+	expected-offset = <0x00000>;
+	expected-size = <0x8000>;
+
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __GPT_LOOPDEV__;
+		barebox,blockdev;
+	};
+
+	partitions {
+		compatible = "fixed-partitions";
+
+		part_state: state {
+			partuuid = __GPT_LOOPDEV_PARTUUID__;
+		};
+	};
+};
+
+&state {
+	backend = <&part_state>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/05-gpt-partition-by-typeuuid.dts b/test/05-gpt-partition-by-typeuuid.dts
new file mode 100644
index 000000000000..ffd4ad9bc55c
--- /dev/null
+++ b/test/05-gpt-partition-by-typeuuid.dts
@@ -0,0 +1,23 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	expected-dev = __GPT_LOOPDEV__;
+	expected-partno = <2>;
+	expected-offset = <0x00000>;
+	expected-size = <0x8000>;
+
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __GPT_LOOPDEV__;
+		barebox,blockdev;
+	};
+};
+
+&state {
+	backend = <&disk>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/06-fixed-partition-by-diskuuid.dts b/test/06-fixed-partition-by-diskuuid.dts
new file mode 100644
index 000000000000..5eeab5b6b22b
--- /dev/null
+++ b/test/06-fixed-partition-by-diskuuid.dts
@@ -0,0 +1,33 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	expected-dev = __GPT_LOOPDEV__;
+	expected-partno = <0>;
+	expected-offset = <0x28000>;
+	expected-size = <0x8000>;
+
+	disk: loopfile {
+		compatible = "barebox,storage-by-uuid";
+		uuid = __GPT_LOOPDEV_DISKUUID__;
+
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			part_state: state@28000 {
+				reg = <0x28000 0x8000>;
+				label = "state";
+			};
+		};
+	};
+};
+
+&state {
+	backend = <&part_state>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/07-raw-disk-fail.dts b/test/07-raw-disk-fail.dts
new file mode 100644
index 000000000000..1d8e8718bbb3
--- /dev/null
+++ b/test/07-raw-disk-fail.dts
@@ -0,0 +1,18 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __RAW_LOOPDEV__;
+		barebox,blockdev;
+	};
+};
+
+&state {
+	backend = <&disk>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/08-gpt-disk-no-typeuuid-fail.dts b/test/08-gpt-disk-no-typeuuid-fail.dts
new file mode 100644
index 000000000000..a5992b711fa1
--- /dev/null
+++ b/test/08-gpt-disk-no-typeuuid-fail.dts
@@ -0,0 +1,18 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __GPT_NO_TYPEUUID_LOOPDEV__;
+		barebox,blockdev;
+	};
+};
+
+&state {
+	backend = <&disk>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/31-fixed-partition-overlaps-two-gpt-partitions.dts b/test/31-fixed-partition-overlaps-two-gpt-partitions.dts
new file mode 100644
index 000000000000..0d58526de8f5
--- /dev/null
+++ b/test/31-fixed-partition-overlaps-two-gpt-partitions.dts
@@ -0,0 +1,34 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	expected-dev = __GPT_LOOPDEV__;
+	expected-partno = <0>;
+	expected-offset = <0x10000>;
+	expected-size = <0x18000>;
+
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __GPT_LOOPDEV__;
+		barebox,blockdev;
+
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			part_state: state@10000 {
+				reg = <0x10000 0x18000>;
+				label = "state";
+			};
+		};
+	};
+};
+
+&state {
+	backend = <&part_state>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/32-fixed-partition-overlaps-two-gpt-partitions-partially.dts b/test/32-fixed-partition-overlaps-two-gpt-partitions-partially.dts
new file mode 100644
index 000000000000..1d8920ecbb98
--- /dev/null
+++ b/test/32-fixed-partition-overlaps-two-gpt-partitions-partially.dts
@@ -0,0 +1,34 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	expected-dev = __GPT_LOOPDEV__;
+	expected-partno = <0>;
+	expected-offset = <0x10000>;
+	expected-size = <0x14000>;
+
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __GPT_LOOPDEV__;
+		barebox,blockdev;
+
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			part_state: state@10000 {
+				reg = <0x10000 0x14000>;
+				label = "state";
+			};
+		};
+	};
+};
+
+&state {
+	backend = <&part_state>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/33-fixed-partition-part-of-gpt-partition.dts b/test/33-fixed-partition-part-of-gpt-partition.dts
new file mode 100644
index 000000000000..e56b11f7c6c0
--- /dev/null
+++ b/test/33-fixed-partition-part-of-gpt-partition.dts
@@ -0,0 +1,34 @@
+/dts-v1/;
+
+#include "barebox-state.dtsi"
+
+/ {
+	expected-dev = __GPT_LOOPDEV__;
+	expected-partno = <2>;
+	expected-offset = <0x00000>;
+	expected-size = <0x2000>;
+
+	disk: loopfile {
+		compatible = "barebox,hostfile";
+		barebox,filename = __GPT_LOOPDEV__;
+		barebox,blockdev;
+
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			part_state: state@20000 {
+				reg = <0x20000 0x2000>;
+				label = "state";
+			};
+		};
+	};
+};
+
+&state {
+	backend = <&part_state>;
+	backend-type = "raw";
+	backend-stridesize = <0x40>;
+	backend-storage-type = "direct";
+};
diff --git a/test/barebox-state.dtsi b/test/barebox-state.dtsi
new file mode 100644
index 000000000000..6a5cc90d5026
--- /dev/null
+++ b/test/barebox-state.dtsi
@@ -0,0 +1,53 @@
+/ {
+	aliases {
+		state = &state;
+	};
+
+	/* State: mutable part */
+	state: state {
+		magic = <0x4d433230>;
+		compatible = "barebox,state";
+
+		bootstate {
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			system0 { /* the node's name here must match the subnode's name in the 'bootstate' node */
+				#address-cells = <1>;
+				#size-cells = <1>;
+
+				remaining_attempts@0 {
+					reg = <0x0 0x4>;
+					type = "uint32";
+					default = <3>;
+				};
+				priority@4 {
+					reg = <0x4 0x4>;
+					type = "uint32";
+					default = <20>;
+				};
+			};
+
+			system1 { /* the node's name here must match the subnode's name in the 'bootstate' node */
+				#address-cells = <1>;
+				#size-cells = <1>;
+
+				remaining_attempts@8 {
+					reg = <0x8 0x4>;
+					type = "uint32";
+					default = <3>;
+				};
+				priority@c {
+					reg = <0xC 0x4>;
+					type = "uint32";
+					default = <20>;
+				};
+			};
+
+			last_chosen@10 {
+				reg = <0x10 0x4>;
+				type = "uint32";
+			};
+		};
+	};
+};
diff --git a/test/barebox-state.t b/test/barebox-state.t
new file mode 100755
index 000000000000..5d34a8d593d1
--- /dev/null
+++ b/test/barebox-state.t
@@ -0,0 +1,229 @@
+#!/bin/sh
+
+set -e
+
+test_description="barebox-state binary tests"
+
+. ./sharness.sh
+
+# Prerequisite: device tree compiler available [DTC]
+dtc --version &&
+  test_set_prereq DTC
+
+# Prerequisite: fdtget available [FDTGET]
+fdtget --version &&
+  test_set_prereq FDTGET
+
+# Prerequisite: C preprocessor available [CPP]
+cpp --version &&
+  test_set_prereq CPP
+
+# Prerequisite: UUID generator available [UUIDGEN]
+uuidgen --version &&
+  test_set_prereq UUIDGEN
+
+# Prerequisite: genimage available [GENIMAGE]
+genimage --version &&
+  test_set_prereq GENIMAGE
+
+# Prerequisite: root available [ROOT]
+whoami | grep -q root &&
+  test_set_prereq ROOT
+
+# Prerequisite: root available [LOSETUP]
+losetup --version  &&
+  test_set_prereq LOSETUP
+
+# Prerequisite: udisksctl available [UDISKSCTL]
+udisksctl help &&
+  test_set_prereq UDISKSCTL
+
+if ! test_have_prereq DTC; then
+  skip_all='skipping all tests, dtc not available'
+  test_done
+fi
+
+if ! test_have_prereq CPP; then
+  skip_all='skipping all tests, cpp not available'
+  test_done
+fi
+
+if ! test_have_prereq GENIMAGE; then
+  skip_all='skipping all tests, genimage not available'
+  test_done
+fi
+
+test_expect_success "barebox-state invalid arg" "
+  test_must_fail barebox-state --foobar baz
+"
+
+test_expect_success "barebox-state missing arg" "
+  test_expect_code 1 barebox-state --get &&
+  test_expect_code 1 barebox-state --set &&
+  test_expect_code 1 barebox-state --name &&
+  test_expect_code 1 barebox-state --input &&
+  test_expect_code 1 barebox-state info
+"
+
+test_expect_success "barebox-state version" "
+  barebox-state --version
+"
+
+test_expect_success "barebox-state help" "
+  barebox-state --help
+"
+
+if test_have_prereq ROOT && test_have_prereq LOSETUP; then
+  loopsetup  () { losetup -P --find --show "$1"; }
+  loopdetach () { losetup --detach "$1"; }
+  losetup=losetup
+elif test_have_prereq UDISKSCTL; then
+  loopsetup  () {
+    output=$(udisksctl loop-setup --file "$1")
+    echo $output | sed -n 's/^Mapped file .* as \(.*\)\.$/\1/p'
+  }
+  loopdetach () { udisksctl loop-delete -b "$1"; }
+  losetup=udiskctl
+else
+  loopsetup  () { :; }
+  loopdetach () { :; }
+fi
+
+# Prerequisite: loop mount possible [LOOP]
+[ -n "$losetup" ] &&
+  test_set_prereq LOOP
+
+TEST_TMPDIR=$(mktemp -d)
+
+if test_have_prereq UUIDGEN; then
+  partuuid="$(uuidgen)"
+  diskuuid="$(uuidgen)"
+else
+  partuuid="1da8efb0-4932-4786-b1fc-50dd3cff212f"
+  diskuuid="30b8d4b2-ec91-4288-9233-cdb643cb5486"
+fi
+
+for config in ${SHARNESS_TEST_DIRECTORY}/*.config; do
+  basename=$(basename $config .config)
+  config_pp=${TEST_TMPDIR}/${basename}.pp.config
+  cpp -o${config_pp} -nostdinc -undef -x assembler-with-cpp \
+    -D__IMAGE__='"'$basename'.hdimg"' \
+    -D__GPT_LOOPDEV_PARTUUID__='"'$partuuid'"' \
+    -D__GPT_LOOPDEV_DISKUUID__='"'$diskuuid'"' $config
+
+  genimage --config=${config_pp} --tmppath="${TEST_TMPDIR}/genimage" \
+    --inputpath="${TEST_TMPDIR}" --outputpath="${TEST_TMPDIR}" \
+    --rootpath="${SHARNESS_TEST_DIRECTORY}"
+done
+
+gptloop=$(loopsetup ${TEST_TMPDIR}/gpt.hdimg)
+gptnouuidloop=$(loopsetup ${TEST_TMPDIR}/gpt-no-typeuuid.hdimg)
+rawloop=$(loopsetup ${TEST_TMPDIR}/raw.hdimg)
+
+for dts in ${SHARNESS_TEST_DIRECTORY}/*.dts; do
+  dtb=$(basename ${dts} .dts).dtb
+  cpp -nostdinc -undef -D__DTS__ -x assembler-with-cpp \
+    -D__GPT_LOOPDEV__='"'$gptloop'"' -D__RAW_LOOPDEV__='"'$rawloop'"' \
+    -D__GPT_NO_TYPEUUID_LOOPDEV__='"'$gptnouuidloop'"' \
+    -D__GPT_LOOPDEV_PARTUUID__='"'$partuuid'"' \
+    -D__GPT_LOOPDEV_DISKUUID__='"'$diskuuid'"' $dts | \
+    dtc -O dtb -o "${TEST_TMPDIR}/${dtb}" -b 0
+
+  if [ "${dtb#*-fail.dtb}" != "$dtb" ]; then
+    test_expect_success LOOP "barebox-state -i ${dtb} --dump" "
+      test_must_fail barebox-state --input ${TEST_TMPDIR}/$dtb --dump
+    "
+    continue
+  fi
+
+  test_expect_success LOOP "barebox-state -i ${dtb} --dump" "
+    barebox-state --input ${TEST_TMPDIR}/$dtb --dump
+  "
+
+  if test_have_prereq FDTGET && test_have_prereq LOOP; then
+    resolution=$(barebox-state --input ${TEST_TMPDIR}/$dtb -vv --dump 2>&1 | \
+      grep 'state: backend resolved to ')
+    partinfo=$(echo $resolution | sed 's/\/state: backend resolved to //gp')
+
+    set $partinfo
+    actual_dev=$1
+    actual_off=$2
+    actual_siz=$3
+
+    expected_fail=$(fdtget -t s ${TEST_TMPDIR}/${dtb} / expected-dev)
+    expected_disk=$(fdtget -t s ${TEST_TMPDIR}/${dtb} / expected-dev)
+    expected_partno=$(fdtget -t u ${TEST_TMPDIR}/${dtb} / expected-partno)
+    if [ "$expected_partno" != "0" ]; then
+      expected_dev="${expected_disk}p${expected_partno}"
+    else
+      expected_dev="${expected_disk}"
+    fi
+    expected_off=$(fdtget -t u ${TEST_TMPDIR}/${dtb} / expected-offset)
+    expected_siz=$(fdtget -t u ${TEST_TMPDIR}/${dtb} / expected-size)
+
+    test_expect_success LOOP "check backend partition device for ${dtb}" "
+      [ "$actual_dev" = "$expected_dev" ]
+    "
+
+    test_expect_success LOOP "check backend partition offset for ${dtb}" "
+      [ "$actual_off" = "$expected_off" ]
+    "
+
+    test_expect_success LOOP "check backend partition size for ${dtb}" "
+      [ "$actual_siz" = "$expected_siz" ]
+    "
+  fi
+
+  test_expect_success LOOP "barebox-state -i ${dtb} --dump-shell" "
+    eval $(barebox-state --input ${TEST_TMPDIR}/$dtb --dump-shell)
+    [ $? -eq 0 ] || return 1
+  "
+
+  test_expect_success LOOP "verify shell dump for ${dtb}" "
+    [ $state_bootstate_system0_remaining_attempts = 3 ] || return 2
+    [ $state_bootstate_system0_priority = 20 ] || return 2
+    [ $state_bootstate_system1_remaining_attempts = 3 ] || return 2
+    [ $state_bootstate_system1_priority = 20 ] || return 2
+  "
+
+  test_expect_success LOOP "barebox-state -i ${dtb} --set bootstate.last_chosen=0" "
+    barebox-state --input ${TEST_TMPDIR}/$dtb --set bootstate.last_chosen=0
+  "
+
+  test_expect_success LOOP "barebox-state -i ${dtb} --dump-shell #2" "
+    eval $(barebox-state --input ${TEST_TMPDIR}/$dtb --dump-shell)
+    [ $? -eq 0 ] || return 1
+  "
+
+  test_expect_success LOOP "verify set for ${dtb} #1" "
+    [ $state_bootstate_last_chosen = 0 ] || return 2
+  "
+
+  test_expect_success LOOP "barebox-state -i ${dtb} --set bootstate.last_chosen=1337" "
+    barebox-state --input ${TEST_TMPDIR}/$dtb --set bootstate.last_chosen=1337
+  "
+
+  test_expect_success LOOP "barebox-state -i ${dtb} --dump-shell #2" "
+    eval $(barebox-state --input ${TEST_TMPDIR}/$dtb --dump-shell)
+    [ $? -eq 0 ] || return 1
+  "
+
+  test_expect_success LOOP "verify set for ${dtb} #2" "
+    #test_when_finished rm -f ${TEST_TMPDIR}/${dtb}
+    [ $state_bootstate_system0_remaining_attempts = 3 ] || return 2
+    [ $state_bootstate_system0_priority = 20 ] || return 2
+    [ $state_bootstate_system1_remaining_attempts = 3 ] || return 2
+    [ $state_bootstate_system1_priority = 20 ] || return 2
+    [ $state_bootstate_last_chosen = 1337 ] || return 2
+  "
+done
+
+loopdetach $rawloop
+loopdetach $gptnouuidloop
+loopdetach $gptloop
+
+rm -rf $TEST_TMPDIR
+
+test_done
+
+# vi: ft=sh
diff --git a/test/gpt-no-typeuuid.config b/test/gpt-no-typeuuid.config
new file mode 100644
index 000000000000..0fa4a20e8324
--- /dev/null
+++ b/test/gpt-no-typeuuid.config
@@ -0,0 +1,33 @@
+image __IMAGE__ {
+	hdimage {
+		align = 32K
+		partition-table-type = gpt
+	}
+
+	partition oldstate {
+		image = /dev/zero
+		in-partition-table = false
+		offset = 32K
+		size = 32K
+	}
+
+	partition part1 {
+		image = /dev/zero
+		size = 64K
+	}
+
+	partition part2 {
+		image = /dev/zero
+		size = 32K
+		partition-uuid = __GPT_LOOPDEV_PARTUUID__
+	}
+
+	partition oldstate2 {
+		image = /dev/zero
+		in-partition-table = false
+		offset = 160K
+		size = 32K
+	}
+}
+
+/* vim: set tabstop=8 noexpandtab : */
diff --git a/test/gpt.config b/test/gpt.config
new file mode 100644
index 000000000000..12f4c0dc27f3
--- /dev/null
+++ b/test/gpt.config
@@ -0,0 +1,35 @@
+image __IMAGE__ {
+	hdimage {
+		align = 32K
+		partition-table-type = gpt
+		disk-uuid = __GPT_LOOPDEV_DISKUUID__
+	}
+
+	partition oldstate {
+		image = /dev/zero
+		in-partition-table = false
+		offset = 32K
+		size = 32K
+	}
+
+	partition part1 {
+		image = /dev/zero
+		size = 64K
+	}
+
+	partition part2 {
+		image = /dev/zero
+		size = 32K
+		partition-type-uuid = 4778ed65-bf42-45fa-9c5b-287a1dc4aab1
+		partition-uuid = __GPT_LOOPDEV_PARTUUID__
+	}
+
+	partition oldstate2 {
+		image = /dev/zero
+		in-partition-table = false
+		offset = 160K
+		size = 32K
+	}
+}
+
+/* vim: set tabstop=8 noexpandtab : */
diff --git a/test/meson.build b/test/meson.build
index 5e073547d79b..ad7a79906aed 100644
--- a/test/meson.build
+++ b/test/meson.build
@@ -24,3 +24,13 @@ foreach test_name : tests
     timeout : 240,
     workdir : meson.source_root())
 endforeach
+
+test(
+  'barebox-state.t',
+  find_program('barebox-state.t'),
+  args : '-v',
+  is_parallel : false,
+  timeout : 300,
+  env : ['SHARNESS_BUILD_DIRECTORY=' + meson.build_root()],
+  workdir : meson.current_source_dir(),
+)
diff --git a/test/raw.config b/test/raw.config
new file mode 100644
index 000000000000..a712d18b7f7d
--- /dev/null
+++ b/test/raw.config
@@ -0,0 +1,24 @@
+image __IMAGE__ {
+	hdimage {
+		align = 32K
+		partition-table-type = none
+	}
+
+	partition oldstate {
+		image = /dev/zero
+		offset = 32K
+		size = 32K
+	}
+
+	partition part1 {
+		image = /dev/zero
+		size = 64K
+	}
+
+	partition part2 {
+		image = /dev/zero
+		size = 32K
+	}
+}
+
+/* vim: set tabstop=8 noexpandtab : */
diff --git a/test/sharness.sh b/test/sharness.sh
new file mode 100755
index 000000000000..3e74eab49727
--- /dev/null
+++ b/test/sharness.sh
@@ -0,0 +1,857 @@
+#!/bin/sh
+#
+# Copyright (c) 2011-2012 Mathias Lafeldt
+# Copyright (c) 2005-2012 Git project
+# Copyright (c) 2005-2012 Junio C Hamano
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see http://www.gnu.org/licenses/ .
+
+# Public: Current version of Sharness.
+SHARNESS_VERSION="1.0.0"
+export SHARNESS_VERSION
+
+# Public: The file extension for tests.  By default, it is set to "t".
+: ${SHARNESS_TEST_EXTENSION:=t}
+export SHARNESS_TEST_EXTENSION
+
+#  Reset TERM to original terminal if found, otherwise save original TERM
+[ "x" = "x$SHARNESS_ORIG_TERM" ] &&
+		SHARNESS_ORIG_TERM="$TERM" ||
+		TERM="$SHARNESS_ORIG_TERM"
+# Public: The unsanitized TERM under which sharness is originally run
+export SHARNESS_ORIG_TERM
+
+# Export SHELL_PATH
+: ${SHELL_PATH:=$SHELL}
+export SHELL_PATH
+
+# For repeatability, reset the environment to a known state.
+# TERM is sanitized below, after saving color control sequences.
+LANG=C
+LC_ALL=C
+PAGER=cat
+TZ=UTC
+EDITOR=:
+export LANG LC_ALL PAGER TZ EDITOR
+unset VISUAL CDPATH GREP_OPTIONS
+
+# Line feed
+LF='
+'
+
+[ "x$TERM" != "xdumb" ] && (
+		[ -t 1 ] &&
+		tput bold >/dev/null 2>&1 &&
+		tput setaf 1 >/dev/null 2>&1 &&
+		tput sgr0 >/dev/null 2>&1
+	) &&
+	color=t
+
+while test "$#" -ne 0; do
+	case "$1" in
+	-d|--d|--de|--deb|--debu|--debug)
+		debug=t; shift ;;
+	-i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
+		immediate=t; shift ;;
+	-l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
+		TEST_LONG=t; export TEST_LONG; shift ;;
+	--in|--int|--inte|--inter|--intera|--interac|--interact|--interacti|--interactiv|--interactive|--interactive-|--interactive-t|--interactive-te|--interactive-tes|--interactive-test|--interactive-tests):
+		TEST_INTERACTIVE=t; export TEST_INTERACTIVE; verbose=t; shift ;;
+	-h|--h|--he|--hel|--help)
+		help=t; shift ;;
+	-v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
+		verbose=t; shift ;;
+	-q|--q|--qu|--qui|--quie|--quiet)
+		# Ignore --quiet under a TAP::Harness. Saying how many tests
+		# passed without the ok/not ok details is always an error.
+		test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
+	--chain-lint)
+		chain_lint=t; shift ;;
+	--no-chain-lint)
+		chain_lint=; shift ;;
+	--no-color)
+		color=; shift ;;
+	--root=*)
+		root=$(expr "z$1" : 'z[^=]*=\(.*\)')
+		shift ;;
+	*)
+		echo "error: unknown test option '$1'" >&2; exit 1 ;;
+	esac
+done
+
+if test -n "$color"; then
+	# Save the color control sequences now rather than run tput
+	# each time say_color() is called.  This is done for two
+	# reasons:
+	#   * TERM will be changed to dumb
+	#   * HOME will be changed to a temporary directory and tput
+	#     might need to read ~/.terminfo from the original HOME
+	#     directory to get the control sequences
+	# Note:  This approach assumes the control sequences don't end
+	# in a newline for any terminal of interest (command
+	# substitutions strip trailing newlines).  Given that most
+	# (all?) terminals in common use are related to ECMA-48, this
+	# shouldn't be a problem.
+	say_color_error=$(tput bold; tput setaf 1) # bold red
+	say_color_skip=$(tput setaf 4) # blue
+	say_color_warn=$(tput setaf 3) # brown/yellow
+	say_color_pass=$(tput setaf 2) # green
+	say_color_info=$(tput setaf 6) # cyan
+	say_color_reset=$(tput sgr0)
+	say_color_="" # no formatting for normal text
+	say_color() {
+		test -z "$1" && test -n "$quiet" && return
+		eval "say_color_color=\$say_color_$1"
+		shift
+		printf "%s\\n" "$say_color_color$*$say_color_reset"
+	}
+else
+	say_color() {
+		test -z "$1" && test -n "$quiet" && return
+		shift
+		printf "%s\n" "$*"
+	}
+fi
+
+TERM=dumb
+export TERM
+
+error() {
+	say_color error "error: $*"
+	EXIT_OK=t
+	exit 1
+}
+
+say() {
+	say_color info "$*"
+}
+
+test -n "$test_description" || error "Test script did not set test_description."
+
+if test "$help" = "t"; then
+	echo "$test_description"
+	exit 0
+fi
+
+exec 5>&1
+exec 6<&0
+if test "$verbose" = "t"; then
+	exec 4>&2 3>&1
+else
+	exec 4>/dev/null 3>/dev/null
+fi
+
+test_failure=0
+test_count=0
+test_fixed=0
+test_broken=0
+test_success=0
+
+die() {
+	code=$?
+	if test -n "$EXIT_OK"; then
+		exit $code
+	else
+		echo >&5 "FATAL: Unexpected exit with code $code"
+		exit 1
+	fi
+}
+
+EXIT_OK=
+trap 'die' EXIT
+
+# Public: Define that a test prerequisite is available.
+#
+# The prerequisite can later be checked explicitly using test_have_prereq or
+# implicitly by specifying the prerequisite name in calls to test_expect_success
+# or test_expect_failure.
+#
+# $1 - Name of prerequisite (a simple word, in all capital letters by convention)
+#
+# Examples
+#
+#   # Set PYTHON prerequisite if interpreter is available.
+#   command -v python >/dev/null && test_set_prereq PYTHON
+#
+#   # Set prerequisite depending on some variable.
+#   test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
+#
+# Returns nothing.
+test_set_prereq() {
+	satisfied_prereq="$satisfied_prereq$1 "
+}
+satisfied_prereq=" "
+
+# Public: Check if one or more test prerequisites are defined.
+#
+# The prerequisites must have previously been set with test_set_prereq.
+# The most common use of this is to skip all the tests if some essential
+# prerequisite is missing.
+#
+# $1 - Comma-separated list of test prerequisites.
+#
+# Examples
+#
+#   # Skip all remaining tests if prerequisite is not set.
+#   if ! test_have_prereq PERL; then
+#       skip_all='skipping perl interface tests, perl not available'
+#       test_done
+#   fi
+#
+# Returns 0 if all prerequisites are defined or 1 otherwise.
+test_have_prereq() {
+	# prerequisites can be concatenated with ','
+	save_IFS=$IFS
+	IFS=,
+	set -- $*
+	IFS=$save_IFS
+
+	total_prereq=0
+	ok_prereq=0
+	missing_prereq=
+
+	for prerequisite; do
+		case "$prerequisite" in
+		!*)
+			negative_prereq=t
+			prerequisite=${prerequisite#!}
+			;;
+		*)
+			negative_prereq=
+		esac
+
+		total_prereq=$(($total_prereq + 1))
+		case "$satisfied_prereq" in
+		*" $prerequisite "*)
+			satisfied_this_prereq=t
+			;;
+		*)
+			satisfied_this_prereq=
+		esac
+
+		case "$satisfied_this_prereq,$negative_prereq" in
+		t,|,t)
+			ok_prereq=$(($ok_prereq + 1))
+			;;
+		*)
+			# Keep a list of missing prerequisites; restore
+			# the negative marker if necessary.
+			prerequisite=${negative_prereq:+!}$prerequisite
+			if test -z "$missing_prereq"; then
+				missing_prereq=$prerequisite
+			else
+				missing_prereq="$prerequisite,$missing_prereq"
+			fi
+		esac
+	done
+
+	test $total_prereq = $ok_prereq
+}
+
+# You are not expected to call test_ok_ and test_failure_ directly, use
+# the text_expect_* functions instead.
+
+test_ok_() {
+	test_success=$(($test_success + 1))
+	say_color "" "ok $test_count - $@"
+}
+
+test_failure_() {
+	test_failure=$(($test_failure + 1))
+	say_color error "not ok $test_count - $1"
+	shift
+	echo "$@" | sed -e 's/^/#	/'
+	test "$immediate" = "" || { EXIT_OK=t; exit 1; }
+}
+
+test_known_broken_ok_() {
+	test_fixed=$(($test_fixed + 1))
+	say_color error "ok $test_count - $@ # TODO known breakage vanished"
+}
+
+test_known_broken_failure_() {
+	test_broken=$(($test_broken + 1))
+	say_color warn "not ok $test_count - $@ # TODO known breakage"
+}
+
+# Public: Execute commands in debug mode.
+#
+# Takes a single argument and evaluates it only when the test script is started
+# with --debug. This is primarily meant for use during the development of test
+# scripts.
+#
+# $1 - Commands to be executed.
+#
+# Examples
+#
+#   test_debug "cat some_log_file"
+#
+# Returns the exit code of the last command executed in debug mode or 0
+#   otherwise.
+test_debug() {
+	test "$debug" = "" || eval "$1"
+}
+
+# Public: Stop execution and start a shell.
+#
+# This is useful for debugging tests and only makes sense together with "-v".
+# Be sure to remove all invocations of this command before submitting.
+test_pause() {
+	if test "$verbose" = t; then
+		"$SHELL_PATH" <&6 >&3 2>&4
+	else
+		error >&5 "test_pause requires --verbose"
+	fi
+}
+
+test_eval_() {
+	# This is a separate function because some tests use
+	# "return" to end a test_expect_success block early.
+	case ",$test_prereq," in
+	*,INTERACTIVE,*)
+		eval "$*"
+		;;
+	*)
+		eval </dev/null >&3 2>&4 "$*"
+		;;
+	esac
+}
+
+test_run_() {
+	test_cleanup=:
+	expecting_failure=$2
+	test_eval_ "$1"
+	eval_ret=$?
+
+	if test "$chain_lint" = "t"; then
+		test_eval_ "(exit 117) && $1"
+		if test "$?" != 117; then
+			error "bug in the test script: broken &&-chain: $1"
+		fi
+	fi
+
+	if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"; then
+		test_eval_ "$test_cleanup"
+	fi
+	if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
+		echo ""
+	fi
+	return "$eval_ret"
+}
+
+test_skip_() {
+	test_count=$(($test_count + 1))
+	to_skip=
+	for skp in $SKIP_TESTS; do
+		case $this_test.$test_count in
+		$skp)
+			to_skip=t
+			break
+		esac
+	done
+	if test -z "$to_skip" && test -n "$test_prereq" && ! test_have_prereq "$test_prereq"; then
+		to_skip=t
+	fi
+	case "$to_skip" in
+	t)
+		of_prereq=
+		if test "$missing_prereq" != "$test_prereq"; then
+			of_prereq=" of $test_prereq"
+		fi
+
+		say_color skip >&3 "skipping test: $@"
+		say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
+		: true
+		;;
+	*)
+		false
+		;;
+	esac
+}
+
+# Public: Run test commands and expect them to succeed.
+#
+# When the test passed, an "ok" message is printed and the number of successful
+# tests is incremented. When it failed, a "not ok" message is printed and the
+# number of failed tests is incremented.
+#
+# With --immediate, exit test immediately upon the first failed test.
+#
+# Usually takes two arguments:
+# $1 - Test description
+# $2 - Commands to be executed.
+#
+# With three arguments, the first will be taken to be a prerequisite:
+# $1 - Comma-separated list of test prerequisites. The test will be skipped if
+#      not all of the given prerequisites are set. To negate a prerequisite,
+#      put a "!" in front of it.
+# $2 - Test description
+# $3 - Commands to be executed.
+#
+# Examples
+#
+#   test_expect_success \
+#       'git-write-tree should be able to write an empty tree.' \
+#       'tree=$(git-write-tree)'
+#
+#   # Test depending on one prerequisite.
+#   test_expect_success TTY 'git --paginate rev-list uses a pager' \
+#       ' ... '
+#
+#   # Multiple prerequisites are separated by a comma.
+#   test_expect_success PERL,PYTHON 'yo dawg' \
+#       ' test $(perl -E 'print eval "1 +" . qx[python -c "print 2"]') == "4" '
+#
+# Returns nothing.
+test_expect_success() {
+	test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
+	test "$#" = 2 || error "bug in the test script: not 2 or 3 parameters to test_expect_success"
+	export test_prereq
+	if ! test_skip_ "$@"; then
+		say >&3 "expecting success: $2"
+		if test_run_ "$2"; then
+			test_ok_ "$1"
+		else
+			test_failure_ "$@"
+		fi
+	fi
+	echo >&3 ""
+}
+
+# Public: Run test commands and expect them to fail. Used to demonstrate a known
+# breakage.
+#
+# This is NOT the opposite of test_expect_success, but rather used to mark a
+# test that demonstrates a known breakage.
+#
+# When the test passed, an "ok" message is printed and the number of fixed tests
+# is incremented. When it failed, a "not ok" message is printed and the number
+# of tests still broken is incremented.
+#
+# Failures from these tests won't cause --immediate to stop.
+#
+# Usually takes two arguments:
+# $1 - Test description
+# $2 - Commands to be executed.
+#
+# With three arguments, the first will be taken to be a prerequisite:
+# $1 - Comma-separated list of test prerequisites. The test will be skipped if
+#      not all of the given prerequisites are set. To negate a prerequisite,
+#      put a "!" in front of it.
+# $2 - Test description
+# $3 - Commands to be executed.
+#
+# Returns nothing.
+test_expect_failure() {
+	test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
+	test "$#" = 2 || error "bug in the test script: not 2 or 3 parameters to test_expect_failure"
+	export test_prereq
+	if ! test_skip_ "$@"; then
+		say >&3 "checking known breakage: $2"
+		if test_run_ "$2" expecting_failure; then
+			test_known_broken_ok_ "$1"
+		else
+			test_known_broken_failure_ "$1"
+		fi
+	fi
+	echo >&3 ""
+}
+
+# Public: Run command and ensure that it fails in a controlled way.
+#
+# Use it instead of "! <command>". For example, when <command> dies due to a
+# segfault, test_must_fail diagnoses it as an error, while "! <command>" would
+# mistakenly be treated as just another expected failure.
+#
+# This is one of the prefix functions to be used inside test_expect_success or
+# test_expect_failure.
+#
+# $1.. - Command to be executed.
+#
+# Examples
+#
+#   test_expect_success 'complain and die' '
+#       do something &&
+#       do something else &&
+#       test_must_fail git checkout ../outerspace
+#   '
+#
+# Returns 1 if the command succeeded (exit code 0).
+# Returns 1 if the command died by signal (exit codes 130-192)
+# Returns 1 if the command could not be found (exit code 127).
+# Returns 0 otherwise.
+test_must_fail() {
+	"$@"
+	exit_code=$?
+	if test $exit_code = 0; then
+		echo >&2 "test_must_fail: command succeeded: $*"
+		return 1
+	elif test $exit_code -gt 129 -a $exit_code -le 192; then
+		echo >&2 "test_must_fail: died by signal: $*"
+		return 1
+	elif test $exit_code = 127; then
+		echo >&2 "test_must_fail: command not found: $*"
+		return 1
+	fi
+	return 0
+}
+
+# Public: Run command and ensure that it succeeds or fails in a controlled way.
+#
+# Similar to test_must_fail, but tolerates success too. Use it instead of
+# "<command> || :" to catch failures caused by a segfault, for instance.
+#
+# This is one of the prefix functions to be used inside test_expect_success or
+# test_expect_failure.
+#
+# $1.. - Command to be executed.
+#
+# Examples
+#
+#   test_expect_success 'some command works without configuration' '
+#       test_might_fail git config --unset all.configuration &&
+#       do something
+#   '
+#
+# Returns 1 if the command died by signal (exit codes 130-192)
+# Returns 1 if the command could not be found (exit code 127).
+# Returns 0 otherwise.
+test_might_fail() {
+	"$@"
+	exit_code=$?
+	if test $exit_code -gt 129 -a $exit_code -le 192; then
+		echo >&2 "test_might_fail: died by signal: $*"
+		return 1
+	elif test $exit_code = 127; then
+		echo >&2 "test_might_fail: command not found: $*"
+		return 1
+	fi
+	return 0
+}
+
+# Public: Run command and ensure it exits with a given exit code.
+#
+# This is one of the prefix functions to be used inside test_expect_success or
+# test_expect_failure.
+#
+# $1   - Expected exit code.
+# $2.. - Command to be executed.
+#
+# Examples
+#
+#   test_expect_success 'Merge with d/f conflicts' '
+#       test_expect_code 1 git merge "merge msg" B master
+#   '
+#
+# Returns 0 if the expected exit code is returned or 1 otherwise.
+test_expect_code() {
+	want_code=$1
+	shift
+	"$@"
+	exit_code=$?
+	if test $exit_code = $want_code; then
+		return 0
+	fi
+
+	echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
+	return 1
+}
+
+# Public: Compare two files to see if expected output matches actual output.
+#
+# The TEST_CMP variable defines the command used for the comparison; it
+# defaults to "diff -u". Only when the test script was started with --verbose,
+# will the command's output, the diff, be printed to the standard output.
+#
+# This is one of the prefix functions to be used inside test_expect_success or
+# test_expect_failure.
+#
+# $1 - Path to file with expected output.
+# $2 - Path to file with actual output.
+#
+# Examples
+#
+#   test_expect_success 'foo works' '
+#       echo expected >expected &&
+#       foo >actual &&
+#       test_cmp expected actual
+#   '
+#
+# Returns the exit code of the command set by TEST_CMP.
+test_cmp() {
+	${TEST_CMP:-diff -u} "$@"
+}
+
+# Public: portably print a sequence of numbers.
+#
+# seq is not in POSIX and GNU seq might not be available everywhere,
+# so it is nice to have a seq implementation, even a very simple one.
+#
+# $1 - Starting number.
+# $2 - Ending number.
+#
+# Examples
+#
+#   test_expect_success 'foo works 10 times' '
+#       for i in $(test_seq 1 10)
+#       do
+#           foo || return
+#       done
+#   '
+#
+# Returns 0 if all the specified numbers can be displayed.
+test_seq() {
+	i="$1"
+	j="$2"
+	while test "$i" -le "$j"
+	do
+		echo "$i" || return
+		i=$(expr "$i" + 1)
+	done
+}
+
+# Public: Check if the file expected to be empty is indeed empty, and barfs
+# otherwise.
+#
+# $1 - File to check for emptyness.
+#
+# Returns 0 if file is empty, 1 otherwise.
+test_must_be_empty() {
+	if test -s "$1"
+	then
+		echo "'$1' is not empty, it contains:"
+		cat "$1"
+		return 1
+	fi
+}
+
+# Public: Schedule cleanup commands to be run unconditionally at the end of a
+# test.
+#
+# If some cleanup command fails, the test will not pass. With --immediate, no
+# cleanup is done to help diagnose what went wrong.
+#
+# This is one of the prefix functions to be used inside test_expect_success or
+# test_expect_failure.
+#
+# $1.. - Commands to prepend to the list of cleanup commands.
+#
+# Examples
+#
+#   test_expect_success 'test core.capslock' '
+#       git config core.capslock true &&
+#       test_when_finished "git config --unset core.capslock" &&
+#       do_something
+#   '
+#
+# Returns the exit code of the last cleanup command executed.
+test_when_finished() {
+	test_cleanup="{ $*
+		} && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
+}
+
+# Public: Schedule cleanup commands to be run unconditionally when all tests
+# have run.
+#
+# This can be used to clean up things like test databases. It is not needed to
+# clean up temporary files, as test_done already does that.
+#
+# Examples:
+#
+#   cleanup mysql -e "DROP DATABASE mytest"
+#
+# Returns the exit code of the last cleanup command executed.
+final_cleanup=
+cleanup() {
+	final_cleanup="{ $*
+		} && (exit \"\$eval_ret\"); eval_ret=\$?; $final_cleanup"
+}
+
+# Public: Summarize test results and exit with an appropriate error code.
+#
+# Must be called at the end of each test script.
+#
+# Can also be used to stop tests early and skip all remaining tests. For this,
+# set skip_all to a string explaining why the tests were skipped before calling
+# test_done.
+#
+# Examples
+#
+#   # Each test script must call test_done at the end.
+#   test_done
+#
+#   # Skip all remaining tests if prerequisite is not set.
+#   if ! test_have_prereq PERL; then
+#       skip_all='skipping perl interface tests, perl not available'
+#       test_done
+#   fi
+#
+# Returns 0 if all tests passed or 1 if there was a failure.
+test_done() {
+	EXIT_OK=t
+
+	if test -z "$HARNESS_ACTIVE"; then
+		test_results_dir="$SHARNESS_TEST_DIRECTORY/test-results"
+		mkdir -p "$test_results_dir"
+		test_results_path="$test_results_dir/$this_test.$$.counts"
+
+		cat >>"$test_results_path" <<-EOF
+		total $test_count
+		success $test_success
+		fixed $test_fixed
+		broken $test_broken
+		failed $test_failure
+
+		EOF
+	fi
+
+	if test "$test_fixed" != 0; then
+		say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
+	fi
+	if test "$test_broken" != 0; then
+		say_color warn "# still have $test_broken known breakage(s)"
+	fi
+	if test "$test_broken" != 0 || test "$test_fixed" != 0; then
+		test_remaining=$(( $test_count - $test_broken - $test_fixed ))
+		msg="remaining $test_remaining test(s)"
+	else
+		test_remaining=$test_count
+		msg="$test_count test(s)"
+	fi
+
+	case "$test_failure" in
+	0)
+		# Maybe print SKIP message
+		if test -n "$skip_all" && test $test_count -gt 0; then
+			error "Can't use skip_all after running some tests"
+		fi
+		[ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
+
+		if test $test_remaining -gt 0; then
+			say_color pass "# passed all $msg"
+		fi
+		say "1..$test_count$skip_all"
+
+		test_eval_ "$final_cleanup"
+
+		test -d "$remove_trash" &&
+		cd "$(dirname "$remove_trash")" &&
+		rm -rf "$(basename "$remove_trash")"
+
+		exit 0 ;;
+
+	*)
+		say_color error "# failed $test_failure among $msg"
+		say "1..$test_count"
+
+		test_eval_ "$final_cleanup"
+
+		test -d "$remove_trash" &&
+		cd "$(dirname "$remove_trash")" &&
+		rm -rf "$(basename "$remove_trash")"
+
+		exit 1 ;;
+
+	esac
+}
+
+# Public: Root directory containing tests. Tests can override this variable,
+# e.g. for testing Sharness itself.
+: ${SHARNESS_TEST_DIRECTORY:=$(pwd)}
+export SHARNESS_TEST_DIRECTORY
+
+# Public: Source directory of test code and sharness library.
+# This directory may be different from the directory in which tests are
+# being run.
+: ${SHARNESS_TEST_SRCDIR:=$(cd $(dirname $0) && pwd)}
+export SHARNESS_TEST_SRCDIR
+
+# Public: Build directory that will be added to PATH. By default, it is set to
+# the parent directory of SHARNESS_TEST_DIRECTORY.
+: ${SHARNESS_BUILD_DIRECTORY:="$SHARNESS_TEST_DIRECTORY/.."}
+PATH="$SHARNESS_BUILD_DIRECTORY:$PATH"
+export PATH SHARNESS_BUILD_DIRECTORY
+
+# Public: Path to test script currently executed.
+SHARNESS_TEST_FILE="$0"
+export SHARNESS_TEST_FILE
+
+# Prepare test area.
+SHARNESS_TRASH_DIRECTORY="trash directory.$(basename "$SHARNESS_TEST_FILE" ".$SHARNESS_TEST_EXTENSION")"
+test -n "$root" && SHARNESS_TRASH_DIRECTORY="$root/$SHARNESS_TRASH_DIRECTORY"
+case "$SHARNESS_TRASH_DIRECTORY" in
+/*) ;; # absolute path is good
+ *) SHARNESS_TRASH_DIRECTORY="$SHARNESS_TEST_DIRECTORY/$SHARNESS_TRASH_DIRECTORY" ;;
+esac
+test "$debug" = "t" || remove_trash="$SHARNESS_TRASH_DIRECTORY"
+rm -rf "$SHARNESS_TRASH_DIRECTORY" || {
+	EXIT_OK=t
+	echo >&5 "FATAL: Cannot prepare test area"
+	exit 1
+}
+
+
+#
+#  Load any extensions in $srcdir/sharness.d/*.sh
+#
+if test -d "${SHARNESS_TEST_SRCDIR}/sharness.d"
+then
+	for file in "${SHARNESS_TEST_SRCDIR}"/sharness.d/*.sh
+	do
+		# Ensure glob was not an empty match:
+		test -e "${file}" || break
+
+		if test -n "$debug"
+		then
+			echo >&5 "sharness: loading extensions from ${file}"
+		fi
+		. "${file}"
+		if test $? != 0
+		then
+			echo >&5 "sharness: Error loading ${file}. Aborting."
+			exit 1
+		fi
+	done
+fi
+
+# Public: Empty trash directory, the test area, provided for each test. The HOME
+# variable is set to that directory too.
+export SHARNESS_TRASH_DIRECTORY
+
+HOME="$SHARNESS_TRASH_DIRECTORY"
+export HOME
+
+mkdir -p "$SHARNESS_TRASH_DIRECTORY" || exit 1
+# Use -P to resolve symlinks in our working directory so that the cwd
+# in subprocesses like git equals our $PWD (for pathname comparisons).
+cd -P "$SHARNESS_TRASH_DIRECTORY" || exit 1
+
+this_test=${SHARNESS_TEST_FILE##*/}
+this_test=${this_test%.$SHARNESS_TEST_EXTENSION}
+for skp in $SKIP_TESTS; do
+	case "$this_test" in
+	$skp)
+		say_color info >&3 "skipping test $this_test altogether"
+		skip_all="skip all tests in $this_test"
+		test_done
+	esac
+done
+
+test -n "$TEST_LONG" && test_set_prereq EXPENSIVE
+test -n "$TEST_INTERACTIVE" && test_set_prereq INTERACTIVE
+
+# Make sure this script ends with code 0
+:
+
+# vi: set ts=4 sw=4 noet :
-- 
2.39.2




^ permalink raw reply	[flat|nested] 9+ messages in thread

* Re: [OSS-Tools] [PATCH 0/5] Add meson support and first test suite
  2023-05-31 15:31 [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Ahmad Fatoum
                   ` (4 preceding siblings ...)
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 5/5] test: add barebox-state loop block device tests Ahmad Fatoum
@ 2023-06-05 10:17 ` Roland Hieber
  2023-06-12 11:57   ` Ahmad Fatoum
  5 siblings, 1 reply; 9+ messages in thread
From: Roland Hieber @ 2023-06-05 10:17 UTC (permalink / raw)
  To: Ahmad Fatoum; +Cc: oss-tools

On Wed, May 31, 2023 at 05:31:20PM +0200, Ahmad Fatoum wrote:
> The barebox,state binding is quite complex and we have a lot of udev
> parsing code that can only be exercised by manually running
> barebox-state on the target. Make development less error prone, by
> adding tests for the block device bindings. EEPROM and MTD can
> follow later.
> 
> Tests are executed by meson as a runner. Patches to teach autotools
> to do the same are welcome, although I think we should follow RAUC's
> steps and eventually deprecate autotools once meson is on par.

Yes.

> The obvious wart is that we build with -fvisibility=hidden on autotools,
> but with meson the same visibility option results in linker errors.
> 
> I have no idea why yet, but that should only make meson-built
> libdt-utils a bit slower without functional change.
> 
> Ahmad Fatoum (5):
>   Add meson as build system
>   state: add option to lock device node
>   meson: add simple integration test
>   libdt: add CONFIG_TEST_LOOPBACK
>   test: add barebox-state loop block device tests

For all:
Tested-by: Roland Hieber <rhi@pengutronix.de>

> 
>  .gitignore                                    |   2 +
>  README                                        |  21 +
>  check-news.sh                                 |  82 ++
>  configure.ac                                  |  11 +
>  meson.build                                   | 163 ++++
>  meson_options.txt                             |  25 +
>  src/barebox-state.c                           |  30 +-
>  src/barebox-state/state.c                     |   4 +
>  src/barebox-state/state.h                     |  21 +
>  src/dt/dt.h                                   |   1 -
>  src/libdt.c                                   |  50 +-
>  test/01-fixed-partition-no-gpt.dts            |  34 +
>  ...2-fixed-partition-before-gpt-partition.dts |  34 +
>  test/03-fixed-partition-is-gpt-partition.dts  |  34 +
>  test/04-gpt-partition-by-partuuid.dts         |  31 +
>  test/05-gpt-partition-by-typeuuid.dts         |  23 +
>  test/06-fixed-partition-by-diskuuid.dts       |  33 +
>  test/07-raw-disk-fail.dts                     |  18 +
>  test/08-gpt-disk-no-typeuuid-fail.dts         |  18 +
>  ...-partition-overlaps-two-gpt-partitions.dts |  34 +
>  ...-overlaps-two-gpt-partitions-partially.dts |  34 +
>  ...-fixed-partition-part-of-gpt-partition.dts |  34 +
>  test/barebox-state.dtsi                       |  53 ++
>  test/barebox-state.t                          | 229 +++++
>  test/crc32.c                                  |  18 +
>  test/gpt-no-typeuuid.config                   |  33 +
>  test/gpt.config                               |  35 +
>  test/meson.build                              |  36 +
>  test/raw.config                               |  24 +
>  test/sharness.sh                              | 857 ++++++++++++++++++
>  version-gen                                   |   3 +
>  version.h.in                                  |   3 +
>  32 files changed, 2012 insertions(+), 16 deletions(-)
>  create mode 100755 check-news.sh
>  create mode 100644 meson.build
>  create mode 100644 meson_options.txt
>  create mode 100644 test/01-fixed-partition-no-gpt.dts
>  create mode 100644 test/02-fixed-partition-before-gpt-partition.dts
>  create mode 100644 test/03-fixed-partition-is-gpt-partition.dts
>  create mode 100644 test/04-gpt-partition-by-partuuid.dts
>  create mode 100644 test/05-gpt-partition-by-typeuuid.dts
>  create mode 100644 test/06-fixed-partition-by-diskuuid.dts
>  create mode 100644 test/07-raw-disk-fail.dts
>  create mode 100644 test/08-gpt-disk-no-typeuuid-fail.dts
>  create mode 100644 test/31-fixed-partition-overlaps-two-gpt-partitions.dts
>  create mode 100644 test/32-fixed-partition-overlaps-two-gpt-partitions-partially.dts
>  create mode 100644 test/33-fixed-partition-part-of-gpt-partition.dts
>  create mode 100644 test/barebox-state.dtsi
>  create mode 100755 test/barebox-state.t
>  create mode 100644 test/crc32.c
>  create mode 100644 test/gpt-no-typeuuid.config
>  create mode 100644 test/gpt.config
>  create mode 100644 test/meson.build
>  create mode 100644 test/raw.config
>  create mode 100755 test/sharness.sh
>  create mode 100755 version-gen
>  create mode 100644 version.h.in
> 
> -- 
> 2.39.2
> 
> 
> 

-- 
Roland Hieber, Pengutronix e.K.          | r.hieber@pengutronix.de     |
Steuerwalder Str. 21                     | https://www.pengutronix.de/ |
31137 Hildesheim, Germany                | Phone: +49-5121-206917-0    |
Amtsgericht Hildesheim, HRA 2686         | Fax:   +49-5121-206917-5555 |



^ permalink raw reply	[flat|nested] 9+ messages in thread

* Re: [OSS-Tools] [PATCH 4/5] libdt: add CONFIG_TEST_LOOPBACK
  2023-05-31 15:31 ` [OSS-Tools] [PATCH 4/5] libdt: add CONFIG_TEST_LOOPBACK Ahmad Fatoum
@ 2023-06-12 11:56   ` Ahmad Fatoum
  0 siblings, 0 replies; 9+ messages in thread
From: Ahmad Fatoum @ 2023-06-12 11:56 UTC (permalink / raw)
  To: Ahmad Fatoum; +Cc: oss-tools

On 31.05.23 17:31, Ahmad Fatoum wrote:
> We have quite a bit of tricky udev and device tree parsing code that is
> only tested manually. Best case we would have tests for this in QEMU,
> but until we do, let's test it with loop devices:
> 
> The downside is that we can only test block devices and that we need
> a tiny bit of code that's not used normally, but on the upside, we
> have tests. :-)
> 
> Signed-off-by: Ahmad Fatoum <a.fatoum@pengutronix.de>
> ---
>  configure.ac |  2 ++
>  meson.build  |  1 +
>  src/dt/dt.h  |  1 -
>  src/libdt.c  | 50 +++++++++++++++++++++++++++++++++++++++++++++++---
>  4 files changed, 50 insertions(+), 4 deletions(-)
> 
> diff --git a/configure.ac b/configure.ac
> index 117a1e169ba9..5b5c74c2b582 100644
> --- a/configure.ac
> +++ b/configure.ac
> @@ -40,6 +40,8 @@ AC_DEFINE(CONFIG_MTD, [1], [Statically define to be enabled to harmonize barebox
>  
>  AC_DEFINE(CONFIG_STATE, [1], [Statically define to be enabled to harmonize barebox' & dt-utils' code base.])
>  
> +AC_DEFINE(CONFIG_TEST_LOOPBACK, [0], [Only enabled in meson for testing.])
> +
>  AC_CHECK_FUNCS([__secure_getenv secure_getenv])
>  
>  my_CFLAGS="-Wall \
> diff --git a/meson.build b/meson.build
> index 1bc32274af07..be92446f137a 100644
> --- a/meson.build
> +++ b/meson.build
> @@ -21,6 +21,7 @@ conf.set10('CONFIG_MTD', true)
>  conf.set10('CONFIG_STATE', true)
>  conf.set10('CONFIG_STATE_BACKWARD_COMPATIBLE', get_option('state-backward-compatibility'))
>  conf.set10('CONFIG_LOCK_DEVICE_NODE', get_option('lock-device'))
> +conf.set10('CONFIG_TEST_LOOPBACK', get_option('tests'))
>  
>  meson.add_dist_script(
>    find_program('check-news.sh').path(),
> diff --git a/src/dt/dt.h b/src/dt/dt.h
> index a4213d49606a..153b56e09a21 100644
> --- a/src/dt/dt.h
> +++ b/src/dt/dt.h
> @@ -220,7 +220,6 @@ extern int of_set_root_node(struct device_node *node);
>  extern int of_platform_populate(struct device_node *root,
>  				const struct of_device_id *matches,
>  				struct device_d *parent);
> -extern struct device_d *of_find_device_by_node(struct device_node *np);
>  
>  int of_device_is_stdout_path(struct device_d *dev);
>  const char *of_get_model(void);
> diff --git a/src/libdt.c b/src/libdt.c
> index af28de6f17c6..7c24c9197c7f 100644
> --- a/src/libdt.c
> +++ b/src/libdt.c
> @@ -2091,6 +2091,22 @@ struct udev_of_path {
>  
>  static LIST_HEAD(udev_of_devices);
>  
> +static const char *udev_device_get_of_path(struct udev_device *dev)
> +{
> +	const char *of_path;
> +
> +	of_path = udev_device_get_property_value(dev, "OF_FULLNAME");
> +	if (of_path)
> +		return of_path;
> +
> +	if (IS_ENABLED(CONFIG_TEST_LOOPBACK) &&
> +	    !strcmp(udev_device_get_subsystem(dev), "block") &&
> +	    !strncmp(udev_device_get_sysname(dev), "loop", 4))
> +		return udev_device_get_sysname(dev);
> +
> +	return NULL;
> +}
> +
>  static void of_scan_udev_devices(void)
>  {
>  	struct udev *udev;
> @@ -2111,6 +2127,8 @@ static void of_scan_udev_devices(void)
>  	udev_enumerate_add_match_subsystem(enumerate, "spi");
>  	udev_enumerate_add_match_subsystem(enumerate, "mtd");
>  	udev_enumerate_add_match_subsystem(enumerate, "amba");
> +	if (IS_ENABLED(CONFIG_TEST_LOOPBACK))
> +		udev_enumerate_add_match_subsystem(enumerate, "block");
>  	udev_enumerate_scan_devices(enumerate);
>  	devices = udev_enumerate_get_list_entry(enumerate);
>  
> @@ -2124,7 +2142,7 @@ static void of_scan_udev_devices(void)
>  		path = udev_list_entry_get_name(dev_list_entry);
>  		dev = udev_device_new_from_syspath(udev, path);
>  
> -		of_path = udev_device_get_property_value(dev, "OF_FULLNAME");
> +		of_path = udev_device_get_of_path(dev);
>  		if (!of_path)
>  			continue;
>  
> @@ -2148,11 +2166,37 @@ struct udev_device *of_find_device_by_node_path(const char *of_full_path)
>  			ret = udev_of_path->udev;
>  			break;
>  		}
> +		if (!strcmp(udev_of_path->of_path, of_full_path)) {
> +			ret = udev_of_path->udev;
> +			break;
> +		}

This if clause is duplicated. Will remove when applying.

>  	}
>  
>  	return ret;
>  }
>  
> +static struct udev_device *of_find_device_by_node(struct device_node *np)
> +{
> +	struct udev_of_path *udev_of_path;
> +	struct udev_device *dev;
> +	const char *filename;
> +
> +	dev = of_find_device_by_node_path(np->full_name);
> +	if (dev)
> +		return dev;
> +
> +	if (IS_ENABLED(CONFIG_TEST_LOOPBACK) &&
> +	    !of_property_read_string(np, "barebox,filename", &filename) &&
> +	    !strncmp(filename, "/dev/", 5)) {
> +		list_for_each_entry(udev_of_path, &udev_of_devices, list) {
> +			if (!strcmp(udev_of_path->of_path, filename + 5))
> +				return udev_of_path->udev;
> +		}
> +	}
> +
> +	return NULL;
> +}
> +
>  static struct udev_device *device_find_mtd_partition(struct udev_device *dev,
>  		const char *name)
>  {
> @@ -2546,7 +2590,7 @@ static int __of_cdev_find(struct device_node *partition_node, struct cdev *cdev)
>  	 * 42e9401bd146 ("mtd: Add partition device node to mtd partition
>  	 * devices").
>  	 */
> -	dev = of_find_device_by_node_path(partition_node->full_name);
> +	dev = of_find_device_by_node(partition_node);
>  	if (dev) {
>  		if (udev_device_is_eeprom(dev))
>  			return udev_parse_eeprom(dev, &cdev->devpath);
> @@ -2619,7 +2663,7 @@ static int __of_cdev_find(struct device_node *partition_node, struct cdev *cdev)
>  		}
>  	}
>  	else {
> -		dev = of_find_device_by_node_path(node->full_name);
> +		dev = of_find_device_by_node(node);
>  		if (!dev) {
>  			fprintf(stderr, "%s: cannot find device from node %s\n", __func__,
>  					node->full_name);

-- 
Pengutronix e.K.                           |                             |
Steuerwalder Str. 21                       | http://www.pengutronix.de/  |
31137 Hildesheim, Germany                  | Phone: +49-5121-206917-0    |
Amtsgericht Hildesheim, HRA 2686           | Fax:   +49-5121-206917-5555 |




^ permalink raw reply	[flat|nested] 9+ messages in thread

* Re: [OSS-Tools] [PATCH 0/5] Add meson support and first test suite
  2023-06-05 10:17 ` [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Roland Hieber
@ 2023-06-12 11:57   ` Ahmad Fatoum
  0 siblings, 0 replies; 9+ messages in thread
From: Ahmad Fatoum @ 2023-06-12 11:57 UTC (permalink / raw)
  To: Roland Hieber; +Cc: oss-tools

On 05.06.23 12:17, Roland Hieber wrote:
> On Wed, May 31, 2023 at 05:31:20PM +0200, Ahmad Fatoum wrote:
>> The barebox,state binding is quite complex and we have a lot of udev
>> parsing code that can only be exercised by manually running
>> barebox-state on the target. Make development less error prone, by
>> adding tests for the block device bindings. EEPROM and MTD can
>> follow later.
>>
>> Tests are executed by meson as a runner. Patches to teach autotools
>> to do the same are welcome, although I think we should follow RAUC's
>> steps and eventually deprecate autotools once meson is on par.
> 
> Yes.
> 
>> The obvious wart is that we build with -fvisibility=hidden on autotools,
>> but with meson the same visibility option results in linker errors.
>>
>> I have no idea why yet, but that should only make meson-built
>> libdt-utils a bit slower without functional change.
>>
>> Ahmad Fatoum (5):
>>   Add meson as build system
>>   state: add option to lock device node
>>   meson: add simple integration test
>>   libdt: add CONFIG_TEST_LOOPBACK
>>   test: add barebox-state loop block device tests
> 
> For all:
> Tested-by: Roland Hieber <rhi@pengutronix.de>

Thanks. Applied to next.

> 
>>
>>  .gitignore                                    |   2 +
>>  README                                        |  21 +
>>  check-news.sh                                 |  82 ++
>>  configure.ac                                  |  11 +
>>  meson.build                                   | 163 ++++
>>  meson_options.txt                             |  25 +
>>  src/barebox-state.c                           |  30 +-
>>  src/barebox-state/state.c                     |   4 +
>>  src/barebox-state/state.h                     |  21 +
>>  src/dt/dt.h                                   |   1 -
>>  src/libdt.c                                   |  50 +-
>>  test/01-fixed-partition-no-gpt.dts            |  34 +
>>  ...2-fixed-partition-before-gpt-partition.dts |  34 +
>>  test/03-fixed-partition-is-gpt-partition.dts  |  34 +
>>  test/04-gpt-partition-by-partuuid.dts         |  31 +
>>  test/05-gpt-partition-by-typeuuid.dts         |  23 +
>>  test/06-fixed-partition-by-diskuuid.dts       |  33 +
>>  test/07-raw-disk-fail.dts                     |  18 +
>>  test/08-gpt-disk-no-typeuuid-fail.dts         |  18 +
>>  ...-partition-overlaps-two-gpt-partitions.dts |  34 +
>>  ...-overlaps-two-gpt-partitions-partially.dts |  34 +
>>  ...-fixed-partition-part-of-gpt-partition.dts |  34 +
>>  test/barebox-state.dtsi                       |  53 ++
>>  test/barebox-state.t                          | 229 +++++
>>  test/crc32.c                                  |  18 +
>>  test/gpt-no-typeuuid.config                   |  33 +
>>  test/gpt.config                               |  35 +
>>  test/meson.build                              |  36 +
>>  test/raw.config                               |  24 +
>>  test/sharness.sh                              | 857 ++++++++++++++++++
>>  version-gen                                   |   3 +
>>  version.h.in                                  |   3 +
>>  32 files changed, 2012 insertions(+), 16 deletions(-)
>>  create mode 100755 check-news.sh
>>  create mode 100644 meson.build
>>  create mode 100644 meson_options.txt
>>  create mode 100644 test/01-fixed-partition-no-gpt.dts
>>  create mode 100644 test/02-fixed-partition-before-gpt-partition.dts
>>  create mode 100644 test/03-fixed-partition-is-gpt-partition.dts
>>  create mode 100644 test/04-gpt-partition-by-partuuid.dts
>>  create mode 100644 test/05-gpt-partition-by-typeuuid.dts
>>  create mode 100644 test/06-fixed-partition-by-diskuuid.dts
>>  create mode 100644 test/07-raw-disk-fail.dts
>>  create mode 100644 test/08-gpt-disk-no-typeuuid-fail.dts
>>  create mode 100644 test/31-fixed-partition-overlaps-two-gpt-partitions.dts
>>  create mode 100644 test/32-fixed-partition-overlaps-two-gpt-partitions-partially.dts
>>  create mode 100644 test/33-fixed-partition-part-of-gpt-partition.dts
>>  create mode 100644 test/barebox-state.dtsi
>>  create mode 100755 test/barebox-state.t
>>  create mode 100644 test/crc32.c
>>  create mode 100644 test/gpt-no-typeuuid.config
>>  create mode 100644 test/gpt.config
>>  create mode 100644 test/meson.build
>>  create mode 100644 test/raw.config
>>  create mode 100755 test/sharness.sh
>>  create mode 100755 version-gen
>>  create mode 100644 version.h.in
>>
>> -- 
>> 2.39.2
>>
>>
>>
> 

-- 
Pengutronix e.K.                           |                             |
Steuerwalder Str. 21                       | http://www.pengutronix.de/  |
31137 Hildesheim, Germany                  | Phone: +49-5121-206917-0    |
Amtsgericht Hildesheim, HRA 2686           | Fax:   +49-5121-206917-5555 |




^ permalink raw reply	[flat|nested] 9+ messages in thread

end of thread, other threads:[~2023-06-12 11:57 UTC | newest]

Thread overview: 9+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2023-05-31 15:31 [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Ahmad Fatoum
2023-05-31 15:31 ` [OSS-Tools] [PATCH 1/5] Add meson as build system Ahmad Fatoum
2023-05-31 15:31 ` [OSS-Tools] [PATCH 2/5] state: add option to lock device node Ahmad Fatoum
2023-05-31 15:31 ` [OSS-Tools] [PATCH 3/5] meson: add simple integration test Ahmad Fatoum
2023-05-31 15:31 ` [OSS-Tools] [PATCH 4/5] libdt: add CONFIG_TEST_LOOPBACK Ahmad Fatoum
2023-06-12 11:56   ` Ahmad Fatoum
2023-05-31 15:31 ` [OSS-Tools] [PATCH 5/5] test: add barebox-state loop block device tests Ahmad Fatoum
2023-06-05 10:17 ` [OSS-Tools] [PATCH 0/5] Add meson support and first test suite Roland Hieber
2023-06-12 11:57   ` Ahmad Fatoum

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox